TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:setCustomBuffInfo(combat)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat)
	self.duration=6000	-- will be recalculated from haste in RJW spell module
	self.icon="Interface\\Icons\\ability_monk_rushingjadewind"

	-- self.tickfrequency=self.duration/9
	-- self.tickonbuffstart=false
	
	self.tickfrequency=self.duration/8
	self.tickonbuffstart=true
	
	self.durationaffectedbyhaste=true
	self.tickfrequencyaffectedbyhaste=true
	

	
	--self.tickfrequency=self.duration/8
	--self.tickonbuffstart=true	
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:OnReapply(existingbuff,executiontime)
	-- don't call super

	-- --TODO: make this work automatically for any buffs with haste-reduces-time flag
	local duration=self.duration*self.combat:GetHasteCastReductionMultiplier()
	existingbuff.expirytime=executiontime+duration
	-- --TODO: cleanup new (unused) buff and any visuals it happens to be using


		-- while the following method is simpler,
		-- RJW misses a tick when the spell is cast and it looks very obvious
			-- we'll use the previous method for now as the missed tick occurs at the end of the buff where it's less noticeable
				-- and from what we tested (Serenity+RJW+RJW_on_cooldown), we get 4 ticks + 9 ticks = no missed ticks at all
					-- ...which should probably be investigated at some point
	-- -- for now, since we replace the old buff,
	-- -- first dispel the old buff,
	-- existingbuff:SelfDispel()
	-- -- then act as thought we never called reapply
	-- tinsert(self.combat.newbuffs,self)
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:step(elapsed,currenttime)
	TRAININGGROUNDS_Buff.step(self,elapsed,currenttime)

end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:OnBuffStart()	
	TRAININGGROUNDS_Buff.OnBuffStart(self)
	--
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:OnBuffTick(ticktime)
	TRAININGGROUNDS_Buff.OnBuffTick(self,ticktime)

	--print("OnBuffTick ",ticktime)

	local minradius=1
	--local maxradius=350
	local maxradius=300
	
	local objlist=self.combat.character.environment:PointCircleCollisionList(self.combat.character.x, self.combat.character.y, minradius, maxradius)
	local wowlist={}
	local i
	for i=1,#objlist,1 do
		local obj=objlist[i]
		if(obj.combat~=nil)then
			--TODO: not isa
			if(obj:isa(TRAININGGROUNDS_Enemy))then		
				tinsert(wowlist,obj)
			end
		end
	end
	
	
	for i=1,#wowlist,1 do		
		local obj=wowlist[i]
		--self.spell is set in Spell_RJW file
		self.combat:ApplyDamageToEnemy(self.spell.aoedamage,obj,self.spell)
	end
		
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind:OnBuffEnd(endtime)
	TRAININGGROUNDS_Buff.OnBuffEnd(self,endtime)
	
end
