
TRAININGGROUNDS_CombatAI = {}
TRAININGGROUNDS_CombatAI.__index = TRAININGGROUNDS_CombatAI

function TRAININGGROUNDS_CombatAI:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_CombatAI)	

	return self
end

function TRAININGGROUNDS_CombatAI:setup(combat)
	self.combat=combat
	
	self.currentspell=nil
	self.prevspell=nil	-- do not confuse with self.combat.previousspell
						--TODO: make it less likely we'll confuse with
	self.recommendedspelltick=0
	self.autoplay=false
	-- this is managed in combatmodule (there is also a combat.lastexecutedspelltime managed in the same place)
	-- with one exception for instant no-cooldown spells; see below
	self.lastexecutedspelltime=0
end

function TRAININGGROUNDS_CombatAI:step(elapsed,currenttime)
	self:SpecificAI(elapsed,currenttime)
	--self:HighlightButton(currenttime)
	if(self.autoplay==true)then
		if(self.currentspell~=nil)then
			if(currenttime>=self.lastexecutedspelltime+500)then
				self.combat:tryQueueSpell(self.currentspell)
				if(self.currentspell.naturaloffcooldowntick<=currenttime)then
					-- if we're reasonably sure the current spell will be cast instantly,
					-- set lastexecutedspelltime now
					-- (we are trying to prevent two instant spells from ending up in the queue at the same time
					--	as they might execute simulataneously if one or both are off GCD)
					self.lastexecutedspelltime=currenttime
				end
			end
		end
	end
	self.prevspell=self.currentspell
end

function TRAININGGROUNDS_CombatAI:SpecificAI(elapsed,currenttime)
	-- override
end

function TRAININGGROUNDS_CombatAI:HighlightButton(currenttime)
	if(self.currentspell~=self.prevspell)then
		self.recommendedspelltick=currenttime
		if(self.prevspell~=nil)then
			ActionButton_HideOverlayGlow(self.prevspell.button.frame)	
		end
		if(self.currentspell~=nil)then
			ActionButton_ShowOverlayGlow(self.currentspell.button.frame)	
		end
	end
end