TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:setup(character)
	TRAININGGROUNDS_CombatModule.setup(self,character)
	
	--self.ai=TRAININGGROUNDS_CombatAI_W7_WindwalkerMonk.new()
	--self.ai:setup(self)
end

TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.FOFDAMAGE=2750
--TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.PLAYERHP=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.FOFDAMAGE*3.5
TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.PLAYERHP=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.FOFDAMAGE*2

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetResources()
		
	self.showtargetcircles=true
	
	self.scktargets={}
		
	--self.hastepercent=(_TRAININGGROUNDS.game.targethaste-1)*0.1
	--tutorial always uses 50% haste
	self.hastepercent=0.50
	
	--self.masterypercent=0.15	
	--TODO: scale mastery with haste?
	--self.masterypercent=0.20
	self.masterypercent=0.20
		
	-- set up resources before applying spells.
	-- spells will link back to these resources
	
	self.energy=TRAININGGROUNDS_Resource.new()	
	local energyregenrate=10.0*(1+self.hastepercent)		
	self.chi=TRAININGGROUNDS_Resource.new()

	if(true)then
		--always use ascension for tutorial
		self.energy:setup(self,"energy",0,130,130,energyregenrate*1.15)
		self.chi:setup(self,"chi",0,6,0,0)
		self.energy.visibleinnameplate=false
		self.chi.visibleinnameplate=false
	end
	self.energy.displaycolor={1,1,0,1}
	self.chi.displaycolor={0.9,0.9,0.9,1}
	self.chi.displaystyle=TRAININGGROUNDS_Resource.DISPLAYSTYLE_CIRCLE
	tinsert(self.resources,self.energy)
	tinsert(self.resources,self.chi)

end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetSpells()	

	self.critterattack=TRAININGGROUNDS_Spell_Tutorial_CritterAttack.new()
	self.critterattack:setup(self)
	tinsert(self.spellbook,self.critterattack)	
	
	self.speedboost=TRAININGGROUNDS_Spell_Tutorial_SpeedBoost.new()
	self.speedboost:setup(self)
	tinsert(self.spellbook,self.speedboost)
	
	self.tutorialroll=TRAININGGROUNDS_Spell_Tutorial_Roll.new()
	self.tutorialroll:setup(self)
	tinsert(self.spellbook,self.tutorialroll)	

	self.tigerpalm=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.new()	
	self.tigerpalm:setup(self)
	tinsert(self.spellbook,self.tigerpalm)	

	self.fistsoffury=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury.new()
	self.fistsoffury:setup(self)
	tinsert(self.spellbook,self.fistsoffury)	
	
	self.strikeofthewindlord=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord.new()
	self.strikeofthewindlord:setup(self)
	tinsert(self.spellbook,self.strikeofthewindlord)	
	
	self.spinningdragonstrike=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike.new()
	self.spinningdragonstrike:setup(self)
	tinsert(self.spellbook,self.spinningdragonstrike)	
	
	self.risingsunkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick.new()
	--self.risingsunkick=TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend.new()	--!!!	for sandbox use only
	self.risingsunkick:setup(self)
	tinsert(self.spellbook,self.risingsunkick)	

	self.rushingjadewind=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind.new()
	self.rushingjadewind:setup(self)
	tinsert(self.spellbook,self.rushingjadewind)	
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==5)then
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst.new()
	else
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave.new()
	end
	self.chiwave:setup(self)
	tinsert(self.spellbook,self.chiwave)
			
	self.blackoutkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick.new()
	self.blackoutkick:setup(self)
	tinsert(self.spellbook,self.blackoutkick)	

	-- spell use counter tracks this
	self.fakecombobreakerblackoutkick=TRAININGGROUNDS_FakeSpell_W7_WindwalkerMonk_ComboBreakerBlackoutKick.new()
	self.fakecombobreakerblackoutkick:setup(self)
	tinsert(self.spellbook,self.fakecombobreakerblackoutkick)

	
	
	-- 4 hits: "Mo-de-ra-te"
	-- 100*4 (in current build, at least)
	self.spinningcranekick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick.new()
	self.spinningcranekick:setup(self)
	tinsert(self.spellbook,self.spinningcranekick)	
	
	self.energizingelixir=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir.new()
	self.energizingelixir:setup(self)
	tinsert(self.spellbook,self.energizingelixir)	


	
	if(false)then	--always use TEB (SE&F) in tutorial
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Serenity.new()
	else
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.new()
	end	
	self.tigereyebrew:setup(self)
	tinsert(self.spellbook,self.tigereyebrew)	
		
	-- "OVERWHELMING"
	-- 8750
	self.touchofdeath=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TouchOfDeath.new()
	self.touchofdeath:setup(self)
	tinsert(self.spellbook,self.touchofdeath)
	
	self.invokexuenthewhitetiger=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger.new()
	self.invokexuenthewhitetiger:setup(self)
	tinsert(self.spellbook,self.invokexuenthewhitetiger)		

	self.roll=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll.new()
	self.roll:setup(self)
	tinsert(self.spellbook,self.roll)
	
	self.tigerslust=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigersLust.new()
	self.tigerslust:setup(self)
	tinsert(self.spellbook,self.tigerslust)	
	
	self.flyingserpentkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick.new()
	self.flyingserpentkick:setup(self)
	tinsert(self.spellbook,self.flyingserpentkick)		
	

	
	-------------------------------------------------------------------------------
	
	--TODO: move to base CombatModule
	self.gcdtracker=TRAININGGROUNDS_FakeSpell_GCDTracker.new()
	self.gcdtracker:setup(self)
	tinsert(self.spellbook,self.gcdtracker)
	

	-- can't safely call ChiOrbit:setup at this point,
	-- so we postpone creating that buff until the spellbutton function
	
end



function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:CreateTutorialSpellButtons(level)
	self:ClearAllSpellButtons()
	self:CreateActionBar()

	
	if(level<=4)then
		self.character.combatstanceidleanimindex=26
	else
		self.character.combatstanceidleanimindex=678
	end
	
	local spellbutton
	if(level==1)then
		--do nothing
		return
	end
	if(level==2)then		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.critterattack,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)		
		--print(spellbutton.frame,spellbutton.frame.framelevel,spellbutton.frame.cooldown,spellbutton.frame.cooldown.framelevel,spellbutton.charges,spellbutton.charges.framelevel)
		--ActionButton_ShowOverlayGlow(spellbutton.frame)
		return
	end
	
	if(level==3)then
		spellbutton=TRAININGGROUNDS_SpellButton.new();	spellbutton:setup(self.critterattack,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tutorialroll,self.actionbar,"8",false,false)		
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.speedboost,self.actionbar,"8",true,false)
		spellbutton.key="R";spellbutton.shift=false
		tinsert(self.spellbuttons,spellbutton)		
		
	end	
	if(level==4)then
		--do nothing
		return
	end
	
		
	--tiger palm
	if(level>=5)then		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigerpalm,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)

		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.roll,self.actionbar,"8",false,false)		
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigerslust,self.actionbar,"8",true,false)
		spellbutton.key="R";spellbutton.shift=false
		tinsert(self.spellbuttons,spellbutton)		

		if(level==5)then 
			self.energy.visibleinnameplate=true
			self.chi.visibleinnameplate=true
			self.energy.value=0
			self:CreateNameplate()
			self:CreateVisibleFrames()	-- cast+channel bar
			--self:CreateVisibleFrames() 
		end
		--if(level==5)then ActionButton_ShowOverlayGlow(spellbutton.frame) end
	end
	
	if(level>=6)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.fistsoffury,self.actionbar,"1",true,false)
		tinsert(self.spellbuttons,spellbutton)
	end
	
	if(level>=7)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.strikeofthewindlord,self.actionbar,"2",false,false)
		tinsert(self.spellbuttons,spellbutton)
	end	
	
	if(level>=8)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.risingsunkick,self.actionbar,"3",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	if(level>=9)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.blackoutkick,self.actionbar,"4",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end			

	if(level>=10)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.spinningcranekick,self.actionbar,"4",true,false)
		tinsert(self.spellbuttons,spellbutton)		
	end

	if(level>=11)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigereyebrew,self.actionbar,"6",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end	
	
	if(level>=12)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.flyingserpentkick,self.actionbar,"9",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	if(level>=13)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.touchofdeath,self.actionbar,"7",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	--always use EotT for tutorial
	if(true)then	
		local eott=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_EyeOfTheTigerController.new()		
		eott:setup(self,self.character.environment.currenttime)
	end
		
	--TODO: clear Combo Breaker buffs before enabling Blackout Kick?
	
	--TODO: drawallcooldowns in parent function
	self:DrawAllCooldowns(self.character.environment.currenttime)
end


function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetSCKTarget(target,impacttime)
	self.scktargets[tostring(target)]=impacttime
end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:GetSCKTargetList()
	return self.scktargets
end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetTTPMultiplierForSpell(spell)
	spell.ttpmultiplier=1
	local ttp=self:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TransferThePower)
	if(ttp~=nil)then
		spell.ttpmultiplier=spell.ttpmultiplier+0.05*ttp.stacks
		ttp:SelfDispel()
	end
end