
TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:setup(character)
	TRAININGGROUNDS_CombatModule.setup(self,character)
	
	--self.ai=TRAININGGROUNDS_CombatAI_W7_WindwalkerMonk.new()
	--self.ai:setup(self)
end

TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.FOFDAMAGE=2750
--TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.FOFDAMAGE*3.5
TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.FOFDAMAGE*2

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:SetResources()
		
	self.showtargetcircles=true
	
	self.scktargets={}
		
	--self.hastepercent=0
	--self.hastepercent=0.15
	--self.hastepercent=0.20
	--self.hastepercent=0.30
	--self.hastepercent=0.50
	
	self.hastepercent=(_TRAININGGROUNDS.game.targethaste-1)*0.1
	
	--self.masterypercent=0.15	
	--TODO: scale mastery with haste?
	--self.masterypercent=0.20
	self.masterypercent=0.20
		
	-- set up resources before applying spells.
	-- spells will link back to these resources
	
	self.energy=TRAININGGROUNDS_Resource.new()	
	local energyregenrate=10.0*(1+self.hastepercent)		
	self.chi=TRAININGGROUNDS_Resource.new()

	if(_TRAININGGROUNDS.game.targettalents==1 or _TRAININGGROUNDS.game.targettalents==4 or _TRAININGGROUNDS.game.targettalents==6)then
		--ascension		
		self.energy:setup(self,"energy",0,130,130,energyregenrate*1.15)
		self.chi:setup(self,"chi",0,6,0,0)
	else
		--not ascension
		self.energy:setup(self,"energy",0,130,130,energyregenrate)
		self.chi:setup(self,"chi",0,5,0,0)		
	end
	self.energy.displaycolor={1,1,0,1}
	self.chi.displaycolor={0.9,0.9,0.9,1}
	self.chi.displaystyle=TRAININGGROUNDS_Resource.DISPLAYSTYLE_CIRCLE
	tinsert(self.resources,self.energy)
	tinsert(self.resources,self.chi)
	

	

end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:SetSpells()	

	self.tigerpalm=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.new()	
	self.tigerpalm:setup(self)
	tinsert(self.spellbook,self.tigerpalm)	

	self.fistsoffury=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury.new()
	self.fistsoffury:setup(self)
	tinsert(self.spellbook,self.fistsoffury)	
	
	self.strikeofthewindlord=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord.new()
	self.strikeofthewindlord:setup(self)
	tinsert(self.spellbook,self.strikeofthewindlord)	
	
	self.spinningdragonstrike=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike.new()
	self.spinningdragonstrike:setup(self)
	tinsert(self.spellbook,self.spinningdragonstrike)	
	
	self.risingsunkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick.new()
	--self.risingsunkick=TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend.new()	--!!!	for sandbox use only
	self.risingsunkick:setup(self)
	tinsert(self.spellbook,self.risingsunkick)	

	self.rushingjadewind=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind.new()
	self.rushingjadewind:setup(self)
	tinsert(self.spellbook,self.rushingjadewind)	
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==5)then
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst.new()
	else
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave.new()
	end
	self.chiwave:setup(self)
	tinsert(self.spellbook,self.chiwave)
			
	self.blackoutkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick.new()
	self.blackoutkick:setup(self)
	tinsert(self.spellbook,self.blackoutkick)	

	-- spell use counter tracks this
	self.fakecombobreakerblackoutkick=TRAININGGROUNDS_FakeSpell_W7_WindwalkerMonk_ComboBreakerBlackoutKick.new()
	self.fakecombobreakerblackoutkick:setup(self)
	tinsert(self.spellbook,self.fakecombobreakerblackoutkick)

	
	
	-- 4 hits: "Mo-de-ra-te"
	-- 100*4 (in current build, at least)
	self.spinningcranekick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick.new()
	self.spinningcranekick:setup(self)
	tinsert(self.spellbook,self.spinningcranekick)	
	
	self.energizingelixir=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir.new()
	self.energizingelixir:setup(self)
	tinsert(self.spellbook,self.energizingelixir)	


	
	if(_TRAININGGROUNDS.game.targettalents==1 or _TRAININGGROUNDS.game.targettalents==4)then
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Serenity.new()
	else
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.new()
	end	
	self.tigereyebrew:setup(self)
	tinsert(self.spellbook,self.tigereyebrew)	
		
	-- "OVERWHELMING"
	-- 8750
	self.touchofdeath=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TouchOfDeath.new()
	self.touchofdeath:setup(self)
	tinsert(self.spellbook,self.touchofdeath)
	
	self.invokexuenthewhitetiger=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger.new()
	self.invokexuenthewhitetiger:setup(self)
	tinsert(self.spellbook,self.invokexuenthewhitetiger)		

	self.roll=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll.new()
	self.roll:setup(self)
	tinsert(self.spellbook,self.roll)
	
	self.tigerslust=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigersLust.new()
	self.tigerslust:setup(self)
	tinsert(self.spellbook,self.tigerslust)	
	
	self.flyingserpentkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick.new()
	self.flyingserpentkick:setup(self)
	tinsert(self.spellbook,self.flyingserpentkick)		
	

	
	-------------------------------------------------------------------------------
	
	--TODO: move to base CombatModule
	self.gcdtracker=TRAININGGROUNDS_FakeSpell_GCDTracker.new()
	self.gcdtracker:setup(self)
	tinsert(self.spellbook,self.gcdtracker)
	

	-- can't safely call ChiOrbit:setup at this point,
	-- so we postpone creating that buff until the spellbutton function
	
end



function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:CreateSpellButtons()
	self:ClearAllSpellButtons()
	self:CreateActionBar()

	-- self.actionbar={}
	-- self.actionbar.frame=TRAININGGROUNDS_ReusableFrames.getFrame()
	-- self.actionbar.frame.parent=_TRAININGGROUNDS.game.environment_ui.frame
	-- self.actionbar.frame:SetWidth(640);self.actionbar.frame:SetHeight(96);
	-- self.actionbar.frame:SetPoint("BOTTOMLEFT",self.actionbar.frame.parent,"BOTTOMLEFT",0,16)
	-- --self.actionbar.frame.texture:Show()
	-- self.actionbar.frame:Show()
	-- --self.actionbar.frame.framelevel=self.character.environment.frame.framelevel+1
	-- self.actionbar.frame.framelevel=_TRAININGGROUNDS.game.environment_ui.frame.framelevel+1
	-- self.actionbar.frame:SetFrameLevel(self.actionbar.frame.framelevel)
	-- self.actionbar.frame:SetParent(self.actionbar.frame.parent)
	
	local spellbutton
											--	    key,shift, ctrl
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.tigerpalm,self.actionbar,"1",false,false)
	tinsert(self.spellbuttons,spellbutton)

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.fistsoffury,self.actionbar,"1",true,false)
	tinsert(self.spellbuttons,spellbutton)

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.strikeofthewindlord,self.actionbar,"2",false,false)
	tinsert(self.spellbuttons,spellbutton)
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==5 or _TRAININGGROUNDS.game.targettalents==6)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.spinningdragonstrike,self.actionbar,"2",true,false)
		tinsert(self.spellbuttons,spellbutton)
	end	
	
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.risingsunkick,self.actionbar,"3",false,false)
	tinsert(self.spellbuttons,spellbutton)	
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==4)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.rushingjadewind,self.actionbar,"3",true,false)
		tinsert(self.spellbuttons,spellbutton)		
	end
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.blackoutkick,self.actionbar,"4",false,false)
	tinsert(self.spellbuttons,spellbutton)
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.spinningcranekick,self.actionbar,"4",true,false)
	tinsert(self.spellbuttons,spellbutton)		

	-- button 5 talent selection is partially handled in spellbook setup
	-- still, skip this button if the player is using EotT
	if(not (_TRAININGGROUNDS.game.targettalents==2))then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.chiwave,self.actionbar,"5",false,false)
		tinsert(self.spellbuttons,spellbutton)
	end
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==5)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.energizingelixir,self.actionbar,"5",true,false)
		tinsert(self.spellbuttons,spellbutton)		
	end
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.tigereyebrew,self.actionbar,"6",false,false)
	tinsert(self.spellbuttons,spellbutton)	

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.touchofdeath,self.actionbar,"7",false,false)
	tinsert(self.spellbuttons,spellbutton)		
	
	if(_TRAININGGROUNDS.game.targettalents==1 or _TRAININGGROUNDS.game.targettalents==2 or _TRAININGGROUNDS.game.targettalents==5)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		--spellbutton:setup(self.invokexuenthewhitetiger,self.actionbar,"(NONE)",false,false)
		--spellbutton:setup(self.invokexuenthewhitetiger,self.actionbar,"=",false,false,12)
		--spellbutton:setup(self.invokexuenthewhitetiger,self.actionbar,"=",false,false,11)
		--spellbutton:setup(self.invokexuenthewhitetiger,self.actionbar,"=",false,false,8)
		spellbutton:setup(self.invokexuenthewhitetiger,self.actionbar,"7",true,false)
		tinsert(self.spellbuttons,spellbutton)	
	end
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.roll,self.actionbar,"8",false,false)	
	tinsert(self.spellbuttons,spellbutton)	
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.tigerslust,self.actionbar,"8",true,false)
	spellbutton.key="R";spellbutton.shift=false
	tinsert(self.spellbuttons,spellbutton)		

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.flyingserpentkick,self.actionbar,"9",false,false)
	tinsert(self.spellbuttons,spellbutton)	
	
	

	
	-- --TODO: do these need to be stored as self.buff?
		-- -- (initial guess: no)
	if(_TRAININGGROUNDS.game.targettalents==2)then
		local chiorbit=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit.new()
		chiorbit:setup(self,self.character.environment.currenttime)
		chiorbit:CalculateDurationAndTickTime()
	end
	
	if(_TRAININGGROUNDS.game.targettalents==2)then
		local powerstrikes=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikesController.new()
		powerstrikes:setup(self,self.character.environment.currenttime)
		powerstrikes:CalculateDurationAndTickTime()	
	end

	if(_TRAININGGROUNDS.game.targettalents==2)then	
		local eott=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_EyeOfTheTigerController.new()
		eott:setup(self,self.character.environment.currenttime)
	end
	
		--TODO: move to CombatModule
	--if(_TRAININGGROUNDS.debug_debugwindow==true)then
	if(true)then
		local i
		local ypos=0
		for i=1,#self.spellbook,1 do
			local spell=self.spellbook[i]
			if(spell.visibletostatistics==true and (spell.button~=nil or spell==self.fakecombobreakerblackoutkick))then
				ypos=ypos+1
				-- local f=TRAININGGROUNDS_ReusableFrames.getFrame()
										-- --TODO: not _TRAININGGROUNDS
				-- f.fontstring:SetParent(_TRAININGGROUNDS.game.debugwindow.environment_ui.frame)
				-- f.fontstring:SetPoint("TOPLEFT",_TRAININGGROUNDS.game.debugwindow.environment_ui.frame,"TOPLEFT",5,(i*-20)+5)
				
				-- f:SetFrameLevel(255)
				-- f:SetWidth(TRAININGGROUNDS_DebugWindow.SCREENWIDTH)
				-- f:SetHeight(20)
				-- f.fontstring:SetText(spell.shortspellname..": 0")
				-- f.fontstring:Show()			
				-- f:Show()
				
				local f=TRAININGGROUNDS_TemporaryTextField.new()
				f:setup(_TRAININGGROUNDS.game.debugwindow.environment_ui)				
				f.frame:SetFrameLevel(255)
				f.frame:SetWidth(TRAININGGROUNDS_DebugWindow.SCREENWIDTH)
				f.frame:SetHeight(20)
				f.frame.fontstring:SetText(spell.shortspellname..": 0")
				f.frame.fontstring:SetJustifyH("LEFT")
				f.x=5
				f.y=(ypos*-20)+5
				
				tinsert(self.debugspelltexts,f)
				
				spell.usecounttextbox=f
			end
		end
	end
	
		--TODO: move debugwindow textboxes to child function...
	--if(_TRAININGGROUNDS.debug_debugwindow==true)then
	if(true)then
		local textbox=TRAININGGROUNDS_TemporaryTextField.new()
		textbox:setup(_TRAININGGROUNDS.game.debugwindow.environment_ui)
		textbox.frame.fontstring:SetJustifyH("LEFT")
		textbox.frame.fontstring:SetText("Total time: 00:00:00")
		textbox.x=5
		textbox.y=-360
		textbox.frame:SetWidth(200)
		textbox:draw()
		textbox.frame:Show()
		self.totaltimetextbox=textbox
		
		local textbox=TRAININGGROUNDS_TemporaryTextField.new()
		textbox:setup(_TRAININGGROUNDS.game.debugwindow.environment_ui)
		textbox.frame.fontstring:SetJustifyH("LEFT")
		textbox.frame.fontstring:SetText("Actions per minute: 00.0")
		textbox.x=5
		textbox.y=-380
		textbox.frame:SetWidth(200)
		textbox:draw()
		textbox.frame:Show()
		self.apmtextbox=textbox		
		
		local textbox=TRAININGGROUNDS_TemporaryTextField.new()
		textbox:setup(_TRAININGGROUNDS.game.debugwindow.environment_ui)
		textbox.frame.fontstring:SetJustifyH("LEFT")
		textbox.frame.fontstring:SetText("Uptime: 00.0%")
		textbox.x=5
		textbox.y=-400
		textbox.frame:SetWidth(200)
		textbox:draw()
		textbox.frame:Show()
		self.uptimetextbox=textbox				
	end
end


function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:SetSCKTarget(target,impacttime)
	self.scktargets[tostring(target)]=impacttime
end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:GetSCKTargetList()
	return self.scktargets
end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:SetTTPMultiplierForSpell(spell)
	spell.ttpmultiplier=1
	local ttp=self:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TransferThePower)
	if(ttp~=nil)then
		spell.ttpmultiplier=spell.ttpmultiplier+0.05*ttp.stacks
		ttp:SelfDispel()
	end
end