TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:setup(character)
	TRAININGGROUNDS_CombatModule.setup(self,character)

end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:SetResources()
		
	self.showtargetcircles=true
	
	-- we need to set up resources because some of the copied spells might try to access them
		-- and we don't have a "resource~=nil" check
	self.energy=TRAININGGROUNDS_Resource.new()	
	self.chi=TRAININGGROUNDS_Resource.new()
	self.energy:setup(self,"energy",0,130,130,10)
	self.chi:setup(self,"chi",0,6,0,0)
	-- self.energy.displaycolor={1,1,0,1}	
	-- self.chi.displaycolor={0.9,0.9,0.9,1}	
	self.chi.visibleinnameplate=false
	self.energy.visibleinnameplate=false	
	tinsert(self.resources,self.energy)
	tinsert(self.resources,self.chi)

	--SEF needs to copy haste for channel time reduction (not sure about mastery)
	self.hastepercent=(_TRAININGGROUNDS.game.targethaste-1)*0.1
	self.masterypercent=0.20

end


function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:SetSpells()	

	self.tigerpalm=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.new()	
	self.tigerpalm:setup(self)
	tinsert(self.spellbook,self.tigerpalm)	

	self.fistsoffury=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury.new()
	self.fistsoffury:setup(self)
	tinsert(self.spellbook,self.fistsoffury)	
	
	self.strikeofthewindlord=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord.new()
	self.strikeofthewindlord:setup(self)
	tinsert(self.spellbook,self.strikeofthewindlord)	
	
	self.spinningdragonstrike=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike.new()
	self.spinningdragonstrike:setup(self)
	tinsert(self.spellbook,self.spinningdragonstrike)	
	
	self.risingsunkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick.new()
	--self.risingsunkick=TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend.new()	--!!!	for sandbox use only
	self.risingsunkick:setup(self)
	tinsert(self.spellbook,self.risingsunkick)	

	self.rushingjadewind=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind.new()
	self.rushingjadewind:setup(self)
	tinsert(self.spellbook,self.rushingjadewind)	
	
	if(_TRAININGGROUNDS.game.targettalents==3 or _TRAININGGROUNDS.game.targettalents==5)then
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst.new()
	else
		self.chiwave=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave.new()
	end
	self.chiwave:setup(self)
	tinsert(self.spellbook,self.chiwave)
			
	self.blackoutkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick.new()
	self.blackoutkick:setup(self)
	tinsert(self.spellbook,self.blackoutkick)	

	-- spell use counter tracks this
	self.fakecombobreakerblackoutkick=TRAININGGROUNDS_FakeSpell_W7_WindwalkerMonk_ComboBreakerBlackoutKick.new()
	self.fakecombobreakerblackoutkick:setup(self)
	tinsert(self.spellbook,self.fakecombobreakerblackoutkick)
	
	-- 4 hits: "Mo-de-ra-te"
	-- 100*4 (in current build, at least)
	self.spinningcranekick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick.new()
	self.spinningcranekick:setup(self)
	tinsert(self.spellbook,self.spinningcranekick)	
	
	self.energizingelixir=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir.new()
	self.energizingelixir:setup(self)
	tinsert(self.spellbook,self.energizingelixir)	
	
	if(_TRAININGGROUNDS.game.targettalents==1 or _TRAININGGROUNDS.game.targettalents==4)then
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Serenity.new()
	else
		self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.new()
	end	
	self.tigereyebrew:setup(self)
	tinsert(self.spellbook,self.tigereyebrew)	
		
	-- "OVERWHELMING"
	-- 8750
	self.touchofdeath=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TouchOfDeath.new()
	self.touchofdeath:setup(self)
	tinsert(self.spellbook,self.touchofdeath)
	
	self.invokexuenthewhitetiger=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger.new()
	self.invokexuenthewhitetiger:setup(self)
	tinsert(self.spellbook,self.invokexuenthewhitetiger)		

	self.roll=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll.new()
	self.roll:setup(self)
	tinsert(self.spellbook,self.roll)
	
	self.tigerslust=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigersLust.new()
	self.tigerslust:setup(self)
	tinsert(self.spellbook,self.tigerslust)	
	
	self.flyingserpentkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick.new()
	self.flyingserpentkick:setup(self)
	tinsert(self.spellbook,self.flyingserpentkick)		
	

	
	-------------------------------------------------------------------------------
	
	--TODO: move to base CombatModule
	self.gcdtracker=TRAININGGROUNDS_FakeSpell_GCDTracker.new()
	self.gcdtracker:setup(self)
	tinsert(self.spellbook,self.gcdtracker)
	

	-- can't safely call ChiOrbit:setup at this point,
	-- so we postpone creating that buff until the spellbutton function
	
end


-- call this even for SEF
-- this is where we set up passive talent buffs
function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:CreateSpellButtons()
	self:ClearAllSpellButtons()
	self:CreateActionBar()
	
	-- --TODO: do these need to be stored as self.buff?
		-- -- (initial guess: no)
	if(_TRAININGGROUNDS.game.targettalents==2)then
		local chiorbit=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit.new()
		chiorbit:setup(self,self.character.environment.currenttime)
		chiorbit:CalculateDurationAndTickTime()
		-- SEFs will CopyChiOrbit on their first step event
	end

	if(_TRAININGGROUNDS.game.targettalents==2)then	
		local eott=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_EyeOfTheTigerController.new()
		eott:setup(self,self.character.environment.currenttime)
	end
	
end


function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:TryMimicSpell(playerspell,executespelltime)	
	TRAININGGROUNDS_CombatModule.TryMimicSpell(self,playerspell,executespelltime)
	--we already checked for procscombostrikes==true in playerspell:executeSuccessfullyCastEnd
--	print("TryMimic",#self.spellbook)
	local i
	local spell=nil
	for i=1,#self.spellbook,1 do
		if(self.spellbook[i].spellname==playerspell.spellname)then
			spell=self.spellbook[i]
			i=#self.spellbook+1	--break loop
		end
	end
	if(spell~=nil)then
		self:tryExecuteSpell(spell,executespelltime,false,false)
	end
	
end



-- if this function is called with cooldownqueued==true,
-- the execute spell tick will be whenever that spell came off cooldown...if that's in the distant past, it could break things.
function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:tryExecuteSpell(spell,currenttime,cooldownqueued,castbarqueued)
	local result=false
	
	if(self.character.deadingame==true)then
		return result
	end

	local r=spell:haveResources()
--print("CombatModule ",self,"!!!")
	
	--TODO: reorder checks to match WoW's error message priority
	
	--SEF ignores castwhilemoving (they don't use casttime)
	--SEF ignores castedspells (they can't casttime anything)
	
	--SEF ignores resources
	--SEF ignores cooldowns
	--SEF *probably* ignores pacifies?  (very hard to check in 6.0 with quick-SCK perk)

	local sck=self:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_SpinningCraneKick)
	-- -- Pacify check (or not)	
	--if(roll==nil and (fsk==nil or spell.name=="Flying Serpent Kick") and sck==nil)then
	if(true)then			
		if(spell:TargetIsOkay(self.character,self.target).success==true)then
			if(spell:RangeIsOkay(self.character,self.target).success==true)then
				local executespelltick=currenttime
				if(cooldownqueued==true and spell.offcooldowntick<currenttime)then
					executespelltick=spell.offcooldowntick
				end
				if(castbarqueued==true and self.castendtime<currenttime)then
					executespelltick=self.castendtime
				end
				if(_TRAININGGROUNDS.debug_printabilityexecutetime==true)then
					print("CombatModule_W7_WindwalkerMonk_SEF.lua casting "..spell.spellname.." at "..executespelltick)
				end

				-- success!
				result=true
				-- normally spell.target is set in CastStart
				-- but we skip CastStart and go straight to CastEnd, so set spell.target now
				spell.target=self.target
				spell:executeSuccessfullyCastEnd(executespelltick)					
				self.movementqueuedspell=nil
				self.cooldownqueuedspell=nil

				self.character.combatstanceendtick=currenttime+5000		-- use this line for the W7 monk test
			else
				--print("SEF spell failed: out of range")
				--TODO: else out of range; display spell error message
				-- SEF can't use movementqueuedspell -- if it's out of range, it's out of range
			end
		else
			--print("SEF spell failed: invalid target")
			--TODO: else invalid target; display spell error message			
			-- SEF can't autotarget (not in this situation, anyway)			
		end
		
	else
		-- else pacified from roll or FSK
	end

	
	--TODO: if spell was TP,BoK,or RSK, consider changing targets

	return result
end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:ApplyDamageToEnemy(damage,enemy,spell)
	--TODO: show debug warning if spell==nil
	
	--we're SEF, so check owner for buffs
		local teb=self.character.owner.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TigereyeBrew)
		if(teb~=nil)then
			damage=damage*1.30
		end
		if(spell~=nil and spell.procscombostrikes==true and self.character.owner.combat.lastattackwasokforcombostrikes==true)then			
			damage=damage*(1+self.masterypercent)	
		end
		local hc=self.character.owner.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_HitCombo)
		if(hc~=nil)then			
			damage=damage*1+0.01*(hc.stacks)
			--print("Hit Combo stacks:",hc.stacks,"multiplier:",1+0.01*(hc.stacks))
		end		
	--end
	
	--we're SEF, so SEF multiplier is always 0.45
	damage=damage*TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.SEFMULTIPLIER
	
	if(enemy.combat:RollToBlock(self.character)==true)then
		--TODO: multiply by block amount
		damage=damage*0
	end
	
	--TODO: buffs, debuffs, crit damage, etc
	self:ApplyExactDamageToEnemy(damage,enemy,spell)
	
end


function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:SetSCKTarget(target,impacttime)
	--print("SetSCKTarget ",target)
	local owner=self.character.owner
	owner.combat.scktargets[tostring(target)]=impacttime
	if(self.character.focustarget==nil)then
		-- if we call AcquireNewTarget right now, 
		-- before the other SEF has attacked,
		-- weird things can happen (SEF#2 will "take over" SEF#1's target)
		-- so have both sefs call acquirenewtarget on the next frame
		self.character.acquirenewtargetnextframe=true
	end
end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:GetSCKTargetList()
	local owner=self.character.owner
	return owner.combat.scktargets
end

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF:SetTTPMultiplierForSpell(spell)
	-- owner's TTP buff was already dispelled, but we stored the multiplier on their FoF spell object
										-- (TODO: do something better)
	spell.ttpmultiplier=self.character.owner.combat.fistsoffury.ttpmultiplier	
end