TRAININGGROUNDS_NameplateCastBar=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ResourceDisplay)


--TODO: shield icon for uninterruptable spells
function TRAININGGROUNDS_NameplateCastBar:setup(nameplate,combat)

	if(self.x==nil)then self.x=1 end
	if(self.wid==nil)then self.wid=100 end

	self.nameplate=nameplate
	self.combat=combat

	self.border=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.border:SetParent(nameplate.character.environment.frame)
	self.border.framelevel=nameplate.frame.framelevel+1
	self.border:SetFrameLevel(self.border.framelevel)
	self.border.texture:SetTexture(1,1,1,1)
	
	self.back=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.back:SetParent(nameplate.character.environment.frame)
	self.back.framelevel=nameplate.frame.framelevel+2
	self.back:SetFrameLevel(self.back.framelevel)
	self.back.texture:SetTexture(0,0,0,1)
	
	self.fill=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.fill:SetParent(nameplate.character.environment.frame)
	self.fill.framelevel=nameplate.frame.framelevel+3
	self.fill:SetFrameLevel(self.fill.framelevel)
	self.fill.texture:SetTexture(1,1,0,1)
	
		
	self.border:Hide()	
	self.border.texture:Show()	
	self.back:Hide()	
	self.back.texture:Show()	
	self.fill:Hide()	
	self.fill.texture:Show()
	
	self.visible=false
end

function TRAININGGROUNDS_NameplateCastBar:SetPointsAndSizes(a,b,c,d,e,wid,hgt)
	--TODO: ask for fillheight, and maybe subtract -1 instead of -2 if zoomed out
	--self.x=d
	local visibleborder=true
	local fillwidth=self:GetFillWidth(wid)-4
	
	
	if(fillwidth<1) then fillwidth=1 end	
	-- <0 causes problems with SetPoint -- must be <1
	--if(fillwidth<0) then fillwidth=0 end
	
	local fillheight=hgt-4
	if(fillheight<2)then fillheight=2;visibleborder=false end

	--!!!
	self.border:ClearAllPoints()
	self.back:ClearAllPoints()
	self.fill:ClearAllPoints()

	
	
	self.border:SetPoint(a,b,c,d,e)
	self.back:SetPoint(a,b,c,d,e-2)
	self.fill:SetPoint(a,b,c,2+d-(wid-(fillwidth))/2,e-2)	-- if zoomed out, 1+d instead of 2+d
	
	

	--fillwidth=wid	
	
	self.border:SetWidth(wid);self.border:SetHeight(hgt)
	self.back:SetWidth(wid-4);self.back:SetHeight(fillheight)
	self.fill:SetWidth(fillwidth);self.fill:SetHeight(fillheight)
	
	
	if(self.combat.castedspell~=nil or self.combat.channeledspell~=nil)then
		if(visibleborder==true)then
			if(self.visible==true)then
				self.border:Show()
			end
		else
			self.border:Hide()
		end
	end
	
	if(self.visible==true)then
		--self.border:Show()		-- this can conflict with the "visibleborder" check above
		self.back:Show()
		self.fill:Show()
	end
	
	if(_TRAININGGROUNDS.game.keys.ctrl.current==true)then
		if(self.visible==true)then
			if(_TRAININGGROUNDS.debug_castbar_troubleshoot==true)then
				print("NameplateCastBar visible: ",self.visible," fill: ")
				TRAININGGROUNDS_FrameVisibilityCheck(self.fill)
			end
		end
	end
end


-- Does not include -4 for visible border.
function TRAININGGROUNDS_NameplateCastBar:GetFillWidth(wid)
	local fraction
	-- print(self)
	-- print(self.max)
	-- print(self.value)
	
	--TODO: 
	if(self.combat.castedspell~=nil)then
		local currenttime=self.combat.character.environment.currenttime
		fraction=(currenttime-self.combat.castedspell.castendtime)/(self.combat.castedspell.caststarttime-self.combat.castedspell.castendtime)	
		fraction=1-fraction
	elseif(self.combat.channeledspell~=nil)then
		local currenttime=self.combat.character.environment.currenttime
		fraction=(currenttime-self.combat.channeledspell.channelendtime)/(self.combat.channeledspell.channelstarttime-self.combat.channeledspell.channelendtime)
	else		
		fraction=0
	end
	
	return fraction*wid	
end


function TRAININGGROUNDS_NameplateCastBar:step(elapsed)
	if(self.combat.castedspell==nil and self.combat.channeledspell==nil)then
		self.border:Hide()
		self.back:Hide()
		self.fill:Hide()
		self.visible=false
	else
		--TODO: copy new visibility system to ResourceDisplay
		self.visible=true
		self.combat.character.redrawnameplates=true
		-- if(self.combat.castedspell~=nil)then
			-- print("castbar cast: ",self.combat.castedspell.spellname)
		-- end		
	end
end


function TRAININGGROUNDS_NameplateCastBar:Cleanup()
	self.border:Cleanup()
	self.back:Cleanup()
	self.fill:Cleanup()
	
end