TRAININGGROUNDS_Resource = {}
TRAININGGROUNDS_Resource.__index = TRAININGGROUNDS_Resource

function TRAININGGROUNDS_Resource:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_Resource)	

	return self
end

TRAININGGROUNDS_Resource.DISPLAYSTYLE_BAR=1
TRAININGGROUNDS_Resource.DISPLAYSTYLE_CIRCLES=2

function TRAININGGROUNDS_Resource:setup(combat,name,min,max,current,regenrate)
	self.combat=combat
	self.name=name
	self.min=min
	self.max=max
	self.value=current	
	self.fill2value=0 -- used for secondary color bar effects like incoming heals
	
	-- this frame is for the text-only debug display
	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()
		
	self.regenrate=regenrate
	
	self.displaystyle=TRAININGGROUNDS_Resource.DISPLAYSTYLE_BAR
	self.visibleinnameplate=true
	self.displaycolor={1,0,0,1}
	self.displaycolor2={0.5,0,0,1}
	
end

function TRAININGGROUNDS_Resource:step(elapsed)
	-- TODO: calculate regen from haste, and maybe don't put regen in resource step
	self:AddToValue(self.regenrate*elapsed)
end

function TRAININGGROUNDS_Resource:setValue(value)
	local oldvalue=self.value

	self.value=value
	if(self.value<self.min)then
		self.value=self.min
	end	
	if(self.value>self.max)then
		self.value=self.max
	end
	
	if(oldvalue~=self.value)then
		if(self.visibleinnameplate==true)then
			self.combat.character.redrawnameplates=true
		end
	end
end

function TRAININGGROUNDS_Resource:SetFill2Value(value)
	local oldvalue=self.fill2value

	self.fill2value=value
	
	if(oldvalue~=self.fill2value)then
		if(self.visibleinnameplate==true)then
			self.combat.character.redrawnameplates=true
		end
	end
end

function TRAININGGROUNDS_Resource:AddToValue(value)	
	if(value<0 and _TRAININGGROUNDS.debug_noresourceloss==true) then return end
	self:setValue(self.value+value)
end

function TRAININGGROUNDS_Resource:draw(currenttime)
	self.frame.fontstring:SetText(self.name..": "..tostring(floor(self.value)))
end

function TRAININGGROUNDS_Resource:GetDisplay()
	-- at the moment most resources can get away with using if-then chains here
	-- so we won't need to override this function for the foreseeable future
	local resource
	if(self.displaystyle==TRAININGGROUNDS_Resource.DISPLAYSTYLE_BAR)then
		resource=TRAININGGROUNDS_ResourceDisplay.new()
	elseif(self.displaystyle==TRAININGGROUNDS_Resource.DISPLAYSTYLE_CIRCLE)then
		resource=TRAININGGROUNDS_ResourceDisplay_Circles.new()
	else
		print("Resource:CreateDisplay WARNING: Unknown resource display style "..tostring(self.displaystyle))
		resource=TRAININGGROUNDS_ResourceDisplay.new()
	end
	return resource
end