TRAININGGROUNDS_ResourceDisplay_Circles=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ResourceDisplay)



function TRAININGGROUNDS_ResourceDisplay_Circles:setup(nameplate,resource)
	if(self.x==nil)then self.x=1 end
	if(self.wid==nil)then self.wid=100 end

	self.nameplate=nameplate
	self.resource=resource
	
	-- Circle display won't change if resource max temporarily increases.	
	self.max=resource.max
	self.previousvalue=resource.value
	self.bordercircles={}
	self.backcircles={}
	self.fillcircles={}
	self.fadecircles={}
	local f
	f=TRAININGGROUNDS_ReusableFrames.getFrame()
	f:SetParent(nameplate.character.environment.frame)
	f.framelevel=nameplate.frame.framelevel
	f:SetWidth(1);f:SetHeight(1)
	f:Show()
	self.containerframe=f
	
	for i=1,self.max,1 do
		
		f=TRAININGGROUNDS_ReusableFrames.getFrame()
		f.i=i
		f:SetParent(nameplate.character.environment.frame)
		f.framelevel=nameplate.frame.framelevel+1
		f:SetFrameLevel(f.framelevel)
		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\blankcircle.tga")		
		tinsert(self.bordercircles,f)
		f:Show();f.texture:Show()
		f=TRAININGGROUNDS_ReusableFrames.getFrame()
		f.i=i
		f:SetParent(nameplate.character.environment.frame)
		f.framelevel=nameplate.frame.framelevel+1
		f:SetFrameLevel(f.framelevel)
		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\blankcircle.tga")
		f.texture:SetGradientAlpha("VERTICAL",0.125,0.125,0.125,1,0.125,0.125,0.125,1)
		tinsert(self.backcircles,f)
		f:Show();f.texture:Show()
		f=TRAININGGROUNDS_ReusableFrames.getFrame()
		f.i=i
		f:SetParent(nameplate.character.environment.frame)
		f.framelevel=nameplate.frame.framelevel+1
		f:SetFrameLevel(f.framelevel)
		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\blankcircle.tga")
		--TODO: set texture gradient to resource displaycolor
		tinsert(self.fillcircles,f)
		f:Hide();f.texture:Show()
		local f
		f=TRAININGGROUNDS_ReusableFrames.getFrame()
		f.i=i
		f:SetParent(nameplate.character.environment.frame)
		f.framelevel=nameplate.frame.framelevel+1
		f:SetFrameLevel(f.framelevel)
		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\blankcircle.tga")
		tinsert(self.fadecircles,f)
		f:Show();f.texture:Show()
		f.alpha=0
		f:SetAlpha(0)
	end

end

function TRAININGGROUNDS_ResourceDisplay_Circles:SetPointsAndSizes(a,b,c,d,e,wid,hgt)
	local circlesize=hgt		-- diameter	
	local backsize=hgt-4
	if(backsize<2)then 
		backsize=2 
		visibleborder=false
	else
		visibleborder=true
	end
	self.containerframe:SetPoint(a,b,c,d,e)
	self.containerframe:SetWidth(wid);self.containerframe:SetHeight(hgt)
	
	for i=1,self.max,1 do
		local f
		borderf=self.bordercircles[i]
		backf=self.backcircles[i]
		fillf=self.fillcircles[i]
		fadef=self.fadecircles[i]
		local xoffset=-hgt*self.max/2	
		xoffset=xoffset-hgt/2
		local yoffset=-hgt
		backf:Show()
		borderf:SetPoint("CENTER",self.containerframe,"CENTER",d+xoffset+i*circlesize,e+yoffset);
		backf:SetPoint("CENTER",self.containerframe,"CENTER",d+xoffset+i*circlesize,e+yoffset);
		fillf:SetPoint("CENTER",self.containerframe,"CENTER",d+xoffset+i*circlesize,e+yoffset);
		fadef:SetPoint("CENTER",self.containerframe,"CENTER",d+xoffset+i*circlesize,e+yoffset);
		borderf:SetWidth(circlesize);backf:SetWidth(backsize);fillf:SetWidth(circlesize)
		borderf:SetHeight(circlesize);backf:SetHeight(backsize);fillf:SetHeight(circlesize)
		fadef:SetAlpha(fadef.alpha)
		fadef:SetWidth(circlesize*(2-fadef.alpha));fadef:SetHeight(circlesize*(2-fadef.alpha))
		-- TODO: at the moment, fillf overlaps borderf
		-- which isn't a bad thing, but the name implies it should work differently
		if(self.resource.value>=i)then
			fillf:Show()
			backf:Hide()
		else
			fillf:Hide()
			backf:Show()
		end
		if(visibleborder==true)then
			borderf:Show()
		else
			borderf:Hide()
		end
	end
	
end

function TRAININGGROUNDS_ResourceDisplay_Circles:SetFrameLevels(layer)
	for i=1,self.max,1 do
		self.bordercircles[i]:SetFrameLevel(layer)
		self.backcircles[i]:SetFrameLevel(layer+1)
	end	
end

function TRAININGGROUNDS_ResourceDisplay_Circles:step(elapsed)
	local f
	for i=1,self.resource.max,1 do
		f=self.fadecircles[i]
		if(f.alpha>-1)then
			f.alpha=f.alpha-elapsed*2
			if(f.alpha>=0)then
				f:SetAlpha(f.alpha)
			end
		end
	end
	
	if(self.previousvalue~=self.resource.value)then
		local changemin=math.min(self.previousvalue,self.resource.value)
		changemin=changemin+1
		--if(changemin<1)then changemin=1 end
		local changemax=math.max(self.previousvalue,self.resource.value)
		
		
		for i=changemin,changemax,1 do
			f=self.fadecircles[i]
			f.alpha=1
		end

		self.previousvalue=self.resource.value
	end
end



function TRAININGGROUNDS_ResourceDisplay_Circles:Cleanup()
	-- don't call super
	-- TODO: put graphics cleanup in a separate function so we can call super
	--	(and do this for any class that uses frames)
	
	for i=1,self.max,1 do
		self.bordercircles[i]:Cleanup()
		self.backcircles[i]:Cleanup()
		self.fillcircles[i]:Cleanup()
		self.fadecircles[i]:Cleanup()
	end
	self.containerframe:Cleanup()
end