-- spellbuttons are activated
-- either via OnClick
-- or in Game.lua's OnKeyDown function.

-- TODO: RegisterForClicks()

TRAININGGROUNDS_SpellButton = {}
TRAININGGROUNDS_SpellButton.__index = TRAININGGROUNDS_SpellButton

function TRAININGGROUNDS_SpellButton:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_SpellButton)
	
	--TODO: multiple possible keybinds per button?
	self.key=nil
	self.ctrl=false
	self.shift=false
	
	self.spell=nil
	

	
	
	return self
end

function TRAININGGROUNDS_SpellButton:setup(spell,actionbar,key,shift,ctrl,xvalue)
	spell.button=self
	self.spell=spell
	self.key=key
	self.shift=shift
	self.ctrl=ctrl
	self.actionbar=actionbar
	if(xvalue~=nil)then
		self.xvalue=xvalue
	else
		self.xvalue=key
	end
	
	local x=tonumber(self.xvalue)*48
	local y=0
	if(shift==true) then y=y+48 end
	
	self.frame=TRAININGGROUNDS_ReusableButtonFrames.getFrame()	
	self.frame.framelevel=actionbar.frame.framelevel+1
	--print("TRAININGGROUNDS_SpellButton  framelevel "..self.frame.framelevel)
	self.frame:SetFrameLevel(self.frame.framelevel)	
	self.frame:SetWidth(48);self.frame:SetHeight(48)
	self.frame:SetPoint("BOTTOMLEFT",actionbar.frame,"BOTTOMLEFT",x,y)
	self.frame:SetParent(actionbar.frame)
	self.frame:Show()
	
	self.frame.texture:SetTexture(spell.icon)	
	self.frame.texture:Show()
	--self.frame.cooldown.framelevel=self.frame.framelevel+1
	self.frame.cooldown.framelevel=self.frame.framelevel+10
	--self.frame.cooldown.framelevel=self.frame.framelevel+5
	self.frame.cooldown:SetFrameLevel(self.frame.cooldown.framelevel)
	self.frame.cooldown:Show()	
	self.frame.cooldown:SetCooldown(0,0)	
	
	--TODO: is this supposed to be Button?  it used to be button, but we figured it was a typo and changed it to ordinary frame
	--self.charges=TRAININGGROUNDS_ReusableButtonFrames.getFrame()	
	self.charges=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.charges.framelevel=self.frame.cooldown.framelevel+10	
	--self.charges.framelevel=self.frame.cooldown.framelevel+5
	-- it doesn't appear to be possible to put the charges indicator above the cooldown indicator
	self.charges:SetFrameLevel(self.charges.framelevel)	
	self.charges:SetWidth(24);self.charges:SetHeight(24)
	self.charges:SetPoint("BOTTOMRIGHT",self.frame,"BOTTOMRIGHT",0,0)
	self.charges:SetParent(actionbar.frame)
	self.charges:Show()
	self.charges.fontstring:SetText("X")
	self.charges.fontstring:Show()
	
	-- "self" refers to the button frame, not SpellButton, during onclick event
	-- so remember it here
	local buttonobject=self
	self.frame:SetScript("OnClick",function(self,button,down)
		--print("spellbuttonclick",buttonobject.spell,buttonobject.spell.combat)
		if(buttonobject.spell~=nil)then
			buttonobject.spell.combat:tryQueueSpell(buttonobject.spell)
		end
	end)
	
end

function TRAININGGROUNDS_SpellButton:Cleanup()
	--TODO: make sure this works properly
	
	self.frame:SetScript("OnClick",nil)
	self.frame:Cleanup()
	self.charges:Cleanup()
	
end