TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Fists of Fury"
	self.shortspellname="FoF"
	
	self.requirefacing=true
	
	self.animationlength=4000
	self.animationsequence=716
	
	self.resource=combat.chi
	self.resourcecost=3
	self.defaultcooldown=24000
	-- self.resourcecost=0		--!!!
	-- self.defaultcooldown=1000 --!!!
	
	
	
	self.channeled=true
	self.channelduration=4000
	self.channeltotalticks=5
	
	
	--self.impacttime=1000
	--5*500, +10%
	self.damage=nil
	--TODO: Crosswinds apparently adds +(8x 100) damage
	self.tickdamage=550
	-- (grand total: 3550 singletarget)
	
	self.primarytarget=nil
	
	self.icon="Interface\\Icons\\monk_ability_fistoffury"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)

	self.primarytarget=self.combat.target
	
	
	--		(index,priority,duration,override,priority2,changeduration)
	local channellength=floor(self.channelduration*self.combat:GetHasteCastReductionMultiplier())
	--TODO:
	self.combat.character:SetAnimationByIndex(self.animationsequence,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,channellength)
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:deductResourceCost()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:GetCooldownForUse()
	local hastecooldown=floor(self.defaultcooldown*self.combat:GetHasteCastReductionMultiplier())

	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil) then
		return hastecooldown/2
	else
		return hastecooldown
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:GetRechargeForUse()
	return self:GetCooldownForUse()
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:OnApplyCooldown()
	if(self.combat.spinningdragonstrike~=nil)then
		self.combat.spinningdragonstrike.fofoffcooldowntick=self.offcooldowntick
	end	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:OnChannelTick(ticktime)
	local minradius=1
	local maxradius=350
	
	local angle
	if(self.combat.channelticksremaining==self.channeltotalticks and self.combat.target~=nil)then
		angle=math.atan2(self.combat.target.y-self.combat.character.y,self.combat.target.x-self.combat.character.x)
	else
		--TODO: function to convert from wowradians to radians
		angle=self.combat.character.currentfacing-math.pi/2
	end	
	
	-- spread of math.pi/2 = +/- 45 degrees = 90 degrees total
	
	local objlist=self.combat.character.environment:PointPieCollisionList(self.combat.character.x, self.combat.character.y, angle, math.pi/4, minradius, maxradius)
	local wowlist={}
	local splitcounter=0
	local i
	for i=1,#objlist,1 do
		local obj=objlist[i]
		if(obj.combat~=nil)then
			--TODO: not isa
			if(obj:isa(TRAININGGROUNDS_Enemy))then		
				tinsert(wowlist,obj)
				splitcounter=splitcounter+1
			end
		end
	end
	
	--TODO: there have been changes to unsplit FoF that aren't reflected here
		-- if FoF reverts to split damage, make a new copy from the unsplit version
	for i=1,#wowlist,1 do		
		local obj=wowlist[i]
		if(obj==self.primarytarget)then
			self.combat:ApplyDamageToEnemy(self.tickdamage,obj,self)			
		else
			self.combat:ApplyDamageToEnemy(self.tickdamage/splitcounter,obj,self)
		end		
		obj:SetAnimationByIndex(14,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,4000/4)
	end
	
	--self.combat:ApplyDamageToEnemy(self.tickdamage,self.combat.target)
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury:ApplySpellAnimation(executespelltime)
	TRAININGGROUNDS_Spell.ApplySpellAnimation(self,executespelltime)
	-- local env=self.combat.character.environment
	-- for i=1,#env.wowcharacters,1 do
		-- local ch=env.wowcharacters[i]
			
		-- if(ch~=self.combat.character)then		
			-- ch.attackanimation=8
			-- ch.attackanimationendtick=executespelltime+750	--TODO: apply haste
			-- ch:changeFrameAnimation(ch.attackanimation)
		-- end
	-- end
end

	