TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Rising Sun Kick"
	self.shortspellname="RSK"
	
	self.requirefacing=true
	
	--self.animationlength=1000
	--self.animationsequence=736
	self.animationname="RisingSunKick"
	
	self.resource=combat.chi
	self.resourcecost=2
	--!!!
	self.defaultcooldown=10000	
	--self.defaultcooldown=8000	--TODO: is it CD*haste-2000 or (CD-2000)*haste?
	
	self.damage=750*1.10	--	rank 3 trait
						-- TODO: after 200 ticks from use, hit again for extra 0.15x damage
	self.impacttime=100
	
	self.procscombostrikes=true
	
	self.icon="Interface\\Icons\\ability_monk_risingsunkick"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:deductResourceCost()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:GetCooldownForUse()
	local hastecooldown=floor(self.defaultcooldown*self.combat:GetHasteCastReductionMultiplier())
	
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil) then
		return hastecooldown/2
	else
		return hastecooldown
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:GetRechargeForUse()
	return self:GetCooldownForUse()
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:OnApplyCooldown()
	if(self.combat.spinningdragonstrike~=nil)then
		self.combat.spinningdragonstrike.rskoffcooldowntick=self.offcooldowntick
	end	
end

--function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:ApplyExecutedSpellSideEffects(executespelltick)
	--TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick:OnImpact(executespelltick)	
	TRAININGGROUNDS_Spell.OnImpact(self,executespelltick)
	
	--TODO: apply on impact
	self.combat:SetSCKTarget(self.target,executespelltick+15000)

		--main 750% damage is applied automatically (in parent function)
	if(self.combat.target~=nil) then		
		local snapshot_damage=self.damage
		local snapshot_target=self.combat.target
		-- self.combat:QueueImpact(executespelltick+self.impacttime*2, 
							-- function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage*0.15,snapshot_target)end)
		--we moved this from sideeffects function
		-- now that we're in onimpact, apply on impacttime instead of impacttime*2
		self.combat:QueueImpact(executespelltick+self.impacttime, 
							function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage*0.15,snapshot_target)end)							
	end
	
	local ttp=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TransferThePower.new()
	ttp:setup(self.combat,self.impacttime)
end