TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Spinning Crane Kick"
	self.shortspellname="SCK"
	
	self.animationlength=1500
	self.animationsequence=660
	
	self.resource=combat.chi
	self.resourcecost=1
	
	self.channeled=true
	self.channelduration=1500
	self.channeltotalticks=4
	
	-- 4*39.96, trait adds another +10%
	self.damage=nil
	self.aoedamage=43.956
	
	self.icon="Interface\\Icons\\ability_monk_cranekick_new"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:ApplyExecutedSpellSideEffects()
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	--		(index,priority,duration,override,priority2,changeduration)
	local channellength=floor(self.channelduration*self.combat:GetHasteCastReductionMultiplier())
	--TODO:
	self.combat.character:SetAnimationByIndex(self.animationsequence,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,channellength)
end	
	
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:deductResourceCost()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:OnChannelStart(starttime)
	local sckbuff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_SpinningCraneKick.new()
	sckbuff:setup(self.combat,starttime)
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:OnChannelStop(ticktime)
	local sckbuff=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_SpinningCraneKick)
	if(sckbuff~=nil)then
		sckbuff:SelfDispel()		
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick:OnChannelTick(ticktime)
	local minradius=1
	--local maxradius=350
	local maxradius=300
	
	
	local objlist=self.combat.character.environment:PointCircleCollisionList(self.combat.character.x, self.combat.character.y, minradius, maxradius)
	local wowlist={}
	local i
	for i=1,#objlist,1 do
		local obj=objlist[i]
		if(obj.combat~=nil)then
			--TODO: not isa
			if(obj:isa(TRAININGGROUNDS_Enemy))then		
				tinsert(wowlist,obj)
			end
		end
	end
	
	
	for i=1,#wowlist,1 do		
		local obj=wowlist[i]
		self.combat:ApplyDamageToEnemy(self.aoedamage,obj,self)	
	end
	
end