TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Strike of the Windlord"
	self.shortspellname="SOTW"
	
	--self.animationlength=1000
	--self.animationsequence=118
	self.animationname="DualWieldFancyAttack"
	
	self.resource=combat.chi
	self.resourcecost=3
	self.defaultcooldown=40000
	--!!!
	-- self.resourcecost=0
	-- self.defaultcooldown=1000
	
	self.impacttime=300
	
	self.requirefacing=true
	
	-- 750*2
	self.damage=nil
	self.aoedamage=750
	
	--self.icon="Interface\\Icons\\spell_frost_windwalkon"
	self.icon="Interface\\Icons\\ability_monk_flyingdragonkick"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:deductResourceCost()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:GetCooldownForUse()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil) then
		return self.defaultcooldown/2
	else
		return self.defaultcooldown
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:GetRechargeForUse()
	return self:GetCooldownForUse()
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:ApplySpellAnimation(executespelltime)
	TRAININGGROUNDS_Spell.ApplySpellAnimation(self,executespelltime)
	-- local env=self.combat.character.environment
	-- for i=1,#env.wowcharacters,1 do
		-- local ch=env.wowcharacters[i]
		
		-- if(ch~=self.combat.character)then
			-- ch.attackanimation=8
			-- ch.attackanimationendtick=executespelltime+750	--TODO: apply haste
			-- ch:changeFrameAnimation(ch.attackanimation)
		-- end
	-- end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	--if(self.combat.target~=nil) then		
		

		--TODO: make consistent with FoF (maybe)
		local minradius=1
		local maxradius=350

		local angle=math.atan2(self.combat.target.y-self.combat.character.y,self.combat.target.x-self.combat.character.x)

		local objlist=self.combat.character.environment:PointPieCollisionList(self.combat.character.x, self.combat.character.y, angle, math.pi/4, minradius, maxradius)
		local wowlist={}
		local i
		for i=1,#objlist,1 do
			local obj=objlist[i]
			if(obj.combat~=nil)then
				--TODO: not isa
				if(obj:isa(TRAININGGROUNDS_Enemy))then		
					tinsert(wowlist,obj)
				end
			end
		end			
		for i=1,#wowlist,1 do		
			local obj=wowlist[i]
			--self.combat:ApplyDamageToEnemy(self.tickdamage,obj)	
			--print(obj,"queue")
			self.combat:QueueImpact(executespelltick+self.impacttime, 
				function(tick)									
					self.combat:ApplyDamageToEnemy(self.aoedamage,obj,self)
					--print(obj,"execute")	
					
					obj:StrikeOfTheWindlordStagger()					
				end)			
			self.combat:QueueImpact(executespelltick+self.impacttime*2, 
				function(tick)									
					self.combat:ApplyDamageToEnemy(self.aoedamage,obj,self)
					--print(obj,"execute")				
				end)
		end																																									
	--end
end