-- A collection of "gamepad" keys intended for arcade gameplay.
-- For spells, use Game>Spells>SpellButton instead.

-- (also stores mouse info)

TRAININGGROUNDS_Keys = {}
TRAININGGROUNDS_Keys.__index = TRAININGGROUNDS_Keys

function TRAININGGROUNDS_Keys:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_Keys)	
	
	self.keys={}
	
	self.up=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.up)
	self.down=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.down)
	self.left=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.left)
	self.right=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.right)
	self.z=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.z)
	self.x=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.x)
	self.space=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.space)	
	self.shift=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.shift)	
	self.ctrl=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.ctrl)	
	self.mouseL=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.mouseL)
	self.mouseM=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.mouseM)		
	self.mouseR=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.mouseR)	
	self.pgup=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.pgup)	
	self.pgdn=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.pgdn)
	self.tab=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.tab)
	self.home=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.home)	
	self.endkey=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.endkey)	
	self.esc=TRAININGGROUNDS_Key:new()
	tinsert(self.keys,self.esc)		
	return self
end

function TRAININGGROUNDS_Keys:step()
	--call step at very end of frame to turn off pressed/released status.
	for k,v in ipairs(self.keys) do			
		v.pressed=false
		v.released=false
	end
	
end