

TRAININGGROUNDS_MenuController_TitleScreen = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_MenuController)

function TRAININGGROUNDS_MenuController_TitleScreen:setup(environment)
	TRAININGGROUNDS_MenuController.setup(self,environment)
	

	-- -- it's already 1 by default
	--environment.camera.zoom=1
	
	
	self.logo=TRAININGGROUNDS_StylizedScrollframeIntroObject.new()
	self.logo:setup(environment)
	self.logo.x=environment.game.SCREENWIDTH/2;self.logo.y=-environment.game.SCREENHEIGHT*.25
	
	--TRAININGGROUNDS_FrameVisibilityCheck(logo.frame)
	self.shuffledclasses=self.GetShuffledClasses()
	
	self.fakepccountdown=2
	self.nextfakepctick=0
	self.fakepc=nil
	
	self.fakepccounter=0
	
	--TODO: constants?
	self.menumode=0			-- 0: no buttons, 1: new game/continue game, 2: stage select, 3: talent select, 4: haste select
	
	self.textbox=TRAININGGROUNDS_TemporaryTextField.new()
	self.textbox:setup(self.environment)
	--TODO: screenwidth instead of 640
	self.textbox.frame:SetWidth(640);self.textbox.frame:SetHeight(50)	
	self.textbox.frame:SetFrameLevel(255)
	self.textbox.frame.fontstring:SetJustifyH("CENTER")		

	self.textbox.x=0
	self.textbox.y=-410	--TODO: -SCREEN_HEIGHT+textboxheight+padding
	self.textbox:draw()
	self.textbox.frame:Show()	
	self.textbox.xspeed=0
	self.textbox.yspeed=0	
	self.textbox.expirytime=nil
	
	self.textbox2=TRAININGGROUNDS_TemporaryTextField.new()
	self.textbox2:setup(self.environment); self.textbox2.frame:SetWidth(640);self.textbox2.frame:SetHeight(50)	; self.textbox2.frame:SetFrameLevel(255); self.textbox2.frame.fontstring:SetJustifyH("CENTER")	
	self.textbox2.x=0; self.textbox2.y=-137
	self.textbox2:draw();	self.textbox2.frame:Show()	;	self.textbox2.xspeed=0;	self.textbox2.yspeed=0	;	self.textbox2.expirytime=nil
	
	
	
	self.menubuttons={}
	
	self.targetstage=1
	self.targettalents=1
	self.targethaste=1
	
end

function TRAININGGROUNDS_MenuController_TitleScreen:GetShuffledClasses()
	local unshuffled={1,2,3,4,5,6,7,8,9,10,11,12}
	local shuffled={}
	local i
	for i=1,12,1 do
		local j=random(#unshuffled)
		tinsert(shuffled,unshuffled[j])
		tremove(unshuffled,j)
	end
	
	-- if(TRAININGGROUNDS_TEMP_ALWAYSMONKFIRST==nil)then
		-- for i=1,12,1 do
			-- if(shuffled[i]==6)then
				-- local j=shuffled[1]
				-- shuffled[1]=shuffled[i]
				-- shuffled[i]=j
				-- i=999	--break
			-- end
		-- end
		-- TRAININGGROUNDS_TEMP_ALWAYSMONKFIRST=false
	-- end	
	-- --!!!
	--shuffled= {6,7,1,2,12,11,3,4,5,8,9,10}
	
	return shuffled
end

function TRAININGGROUNDS_MenuController_TitleScreen:step(elapsed)
	TRAININGGROUNDS_MenuController.step(self,elapsed)
	
	if(self.fakepc~=nil)then
		if(self.fakepc.dead==true)then
			--print("TRAININGGROUNDS_MenuController_TitleScreen fakepc dead")
			self.fakepc=nil
		end
	end
	
	
	
	if(self.environment.currenttime>self.nextfakepctick)then
		self.nextfakepctick=self.nextfakepctick+1000
		if(self.logo.status==TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_DONE)then		
			if(self.menumode==0)then
				self:ChangeMenuMode(1)
			end
			if(self.fakepc==nil)then
				self.fakepccountdown=self.fakepccountdown-1
				if(self.fakepccountdown<=0)then				
					self.fakepccountdown=1+random(3)
					--print("TRAININGGROUNDS_MenuController_TitleScreen:step fakepc")
					local classindex=self.shuffledclasses[1]
					tremove(self.shuffledclasses,1)
					if(#self.shuffledclasses==0)then
						self.shuffledclasses=self.GetShuffledClasses()
						if(self.shuffledclasses[1]==classindex)then
							-- if we'd have two in a row, swap first with last
							self.shuffledclasses[1],self.shuffledclasses[12]=self.shuffledclasses[12],self.shuffledclasses[1]
						end
					end
					
					self.fakepccounter=self.fakepccounter+1
					local enablesilly=false
					if(self.fakepccounter>=3)then enablesilly=true end
					
					local class=TRAININGGROUNDS_FakePlayerCharacter.GetClassByIndex(classindex)
					local fakepc=class.new()
					--local fakepc=TRAININGGROUNDS_FakePlayerCharacter_Warrior.new()					
					fakepc:setup(self.environment)
					
					self.fakepc=fakepc					
					local x=math.random(TRAININGGROUNDS_Game.SCREENWIDTH-100)+50
					fakepc.x=x
					fakepc.y=-TRAININGGROUNDS_Game.SCREENHEIGHT+25
					local facing=math.random()*1.57
					if(x<100)then
						facing=math.abs(facing)
					elseif(x>TRAININGGROUNDS_Game.SCREENWIDTH-100)then
						facing=-math.abs(facing)
					else
						if(math.random()>0.5)then
							facing=-facing
						end
					end
					--facing=1.57--!!!
					self.fakepc:changeFacing(facing,1,1000)
					self.fakepc:SetExtraScale(2)
					self.fakepc:SetRandomTitleScreenAnimationSequence(enablesilly)					
					
					--self.fakepc.expirytime=self.environment.currenttime+3000 --!!!					
					
				end
			end
		end		
	end
	local text=""
	for i=1,#self.menubuttons,1 do
		local btn=self.menubuttons[i]		
		-- some buttons might be grayed out/disabled, so check button #1,
		-- which just so happens (TODO:) to always be enabled
		if(btn.ismouseovered==true and self.menubuttons[1].currentalpha>=.75)then
			text=btn.mouseovertext
		end
	end
	self.textbox.frame.fontstring:SetText(text)
	
	if(self.menumode==0)then
		if(_TRAININGGROUNDS.debug_quickmenu==true)then
			self:ChangeMenuMode(1)
		end
		-- otherwise do nothing	
	elseif(self.menumode==1)then
		--menubutton:SetText("Continue")
	elseif(self.menumode==2)then
	
	end	
	
	if(self.environment.game.keys.esc.pressed==true)then
		if(self.menumode==0 or self.menumode==1 or self.menumode==2)then
			_TRAININGGROUNDS:die()
		elseif(self.menumode==3)then
			self:ChangeMenuMode(2)
		elseif(self.menumode==4)then
			self:ChangeMenuMode(3)
		end
	end
	
	if(self.menubuttons[1]~=nil)then
		if(self.menubuttons[1].currentalpha<=0.5)then
			self.textbox2.frame.fontstring:SetText("")
		else
			if(self.menumode==2)then
				self.textbox2.frame.fontstring:SetText("Select a stage.")
			elseif(self.menumode==3)then
				self.textbox2.frame.fontstring:SetText("Select talents.")
			elseif(self.menumode==4)then
				self.textbox2.frame.fontstring:SetText("Select Haste level.")
			end
		end
	else
		self.textbox2.frame.fontstring:SetText("")
	end
	
	-- for i=1,#self.menubuttons,1 do		
		-- ActionButton_HideOverlayGlow(self.menubuttons[i].frame)
	-- end
	
end

function TRAININGGROUNDS_MenuController_TitleScreen:ChangeMenuMode(newmode)
	local currenttime=self.environment.currenttime
	
	local i
	for i=1,#self.menubuttons,1 do
		--self.menubuttons[i]:Cleanup()	
		--self.menubuttons[i]:die()
		self.menubuttons[i].frame:EnableMouse(false)
		self.menubuttons[i].expirytime=currenttime+1000
		self.menubuttons[i].targetalpha=0
		--print("TRAININGGROUNDS_MenuController_TitleScreen:ChangeMenuMode")
	end	
	self.menubuttons={}
	
	if(newmode==-1)then
		-- do nothing; transitioning to game
	elseif(newmode==1)then
		local menubutton=TRAININGGROUNDS_MenuButton.new()
		menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2
		menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2
		menubutton:Resize(160,100) ;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1
		if(TRAININGGROUNDS_VARS.progress==nil or TRAININGGROUNDS_VARS.progress<=1)then
			menubutton:SetText("New game")
			menubutton.mouseovertext=""
		else
			menubutton:SetText("Continue")
			menubutton.mouseovertext="(You can erase saved data by typing /tg reset)"
		end
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self:ChangeMenuMode(2) end)
		menubutton:draw()
		--TODO: also set framelevel of menubutton's child frames?
		menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		
		--print("MenuController_TitleScreen")
		--TRAININGGROUNDS_FrameVisibilityCheck(menubutton.textframe)
	elseif(newmode==2)then
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2-200;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2
		menubutton:Resize(160,100)
		menubutton:SetText("Demo stage 1"..string.char(13).."Tutorial") ; menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1
		menubutton.mouseovertext="Review basic controls"..string.char(13).."and learn the fundamentals of 7.0 Windwalker Monk."
		menubutton.frame:SetScript("OnClick",function() self.targetstage=1; ActionButton_ShowOverlayGlow(menubutton.frame); self:StartGame() end)
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2
		menubutton:Resize(160,100);	menubutton:SetText("Demo stage 2"..string.char(13).."Endless Waves") ; menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1
		if(TRAININGGROUNDS_VARS.progress==nil or TRAININGGROUNDS_VARS.progress<2)then
			menubutton.targetalpha=0.3
			menubutton.mouseovertext=""
			menubutton.frame:SetScript("OnClick",function() menubutton.mouseovertext="Finish the tutorial to unlock this stage." end)
		else
			menubutton.mouseovertext="Mow down waves of enemies"..string.char(13).."based on Proving Grounds: Basic Damage (Bronze)."
			menubutton.frame:SetScript("OnClick",function() self.targetstage=2; ActionButton_ShowOverlayGlow(menubutton.frame); self:ChangeMenuMode(3) end)
		end
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2+200;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2
		menubutton:Resize(160,100);	menubutton:SetText("Demo stage 3"..string.char(13).."Sustained Workout")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1
		if(TRAININGGROUNDS_VARS.progress==nil or TRAININGGROUNDS_VARS.progress<2)then
			menubutton.targetalpha=0.3
			menubutton.mouseovertext=""
			menubutton.frame:SetScript("OnClick",function() menubutton.mouseovertext="Finish the tutorial to unlock this stage." end)			
		else
			menubutton.mouseovertext="Practice your rotation on a single sturdy enemy."
			menubutton.frame:SetScript("OnClick",function() self.targetstage=3; ActionButton_ShowOverlayGlow(menubutton.frame); self:ChangeMenuMode(3) end)
		end
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)				
	elseif(newmode==3)then
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2-180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("Single target,"..string.char(13).."high APM")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Chi Wave, Ascension, Xuen, and Serenity."..string.char(13)..
								"An active, button mashing set of talents for fighting a single enemy."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targettalents=1; self:ChangeMenuMode(4) end)
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)	
	
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("Single target,"..string.char(13).."low APM")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Eye of the Tiger, Power Strikes, Xuen, and Chi Orbit."..string.char(13)..
							"A passive, relaxing set of talents for fighting a single enemy."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targettalents=2; self:ChangeMenuMode(4) end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2+180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("Area of effect")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Chi Burst, Energizing Elixir, Rushing Jade Wind, and Whirling Dragon Punch."..string.char(13)..
							"A set of AOE talents for fighting multiple enemies."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targettalents=3; self:ChangeMenuMode(4) end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)		
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2-180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("All-purpose"..string.char(13).."mix 1")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Chi Wave, Ascension, Rushing Jade Wind, and Serenity."..string.char(13)..
								"A mix of talents for ST and AOE fights."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targettalents=4; self:ChangeMenuMode(4) end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)	
	
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("All-purpose"..string.char(13).."mix 2")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Chi Burst, Energizing Elixir, Xuen, and Whirling Dragon Punch."..string.char(13)..
								"A mix of talents for ST and AOE fights."
		menubutton.frame:SetScript("OnClick",function()ActionButton_ShowOverlayGlow(menubutton.frame);  self.targettalents=5; self:ChangeMenuMode(4) end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2+180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("Hit Combo")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Chi Wave, Ascension, Hit Combo, and Whirling Dragon Punch."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targettalents=6; self:ChangeMenuMode(4) end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)				
	elseif(newmode==4)then
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2-180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("0% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Minimum possible haste rating."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=1; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)	
	
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("10% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Start of the expansion, mastery build."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=2; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2+180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+60
		menubutton:Resize(160,100);	menubutton:SetText("20% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="End of the expansion, mastery build."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=3; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)		
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2-180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("30% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Start of the expansion, haste build."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=4; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)		

		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("40% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="Middle of the expansion, haste build."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=5; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)						
		
		local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
		menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-160/2+180;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2-60
		menubutton:Resize(160,100);	menubutton:SetText("50% Haste")	;menubutton:SetCurrentAlpha(-1); menubutton.targetalpha=1;		
		menubutton.mouseovertext="End of the expansion, haste build."
		menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); self.targethaste=6; self:StartGame() end)			
		menubutton:draw();	menubutton.frame:SetFrameLevel(150)
		tinsert(self.menubuttons,menubutton)				
	elseif(newmode==5)then
		--else do nothing; starting game
	end
	
	self.menumode=newmode
end

function TRAININGGROUNDS_MenuController_TitleScreen:StartGame()
	self:ChangeMenuMode(5)
	--print("Start game --!!!")
	
	_TRAININGGROUNDS.game.targetstage=self.targetstage
	_TRAININGGROUNDS.game.targettalents=self.targettalents
	_TRAININGGROUNDS.game.targethaste=self.targethaste
	
	_TRAININGGROUNDS.game:StartGame()
	
	
end






function TRAININGGROUNDS_MenuController_TitleScreen:Cleanup()
	--TODO:
	
	
	-- no need to clean up menubuttons from here; environment will take care of that
	self.menubuttons={}
end