
-- these are more or less identical to ModelFrames
-- except we reserve these for "particle" effects
-- (models which don't support customcamera)
-- because "particle" frames malfunction if we try to recycle them for customcamera models.

TRAININGGROUNDS_ReusableParticleFrames = {}

TRAININGGROUNDS_ReusableParticleFrames.inactiveframes={}
TRAININGGROUNDS_ReusableParticleFrames.activeframes={}

function TRAININGGROUNDS_ReusableParticleFrames.removeFrame(f)
	f:SetLight(1,0,-1,0,0,1)
	f:Hide()
	f:ClearAllPoints()	
	f:SetModelScale(1)
	f.texture:SetTexture(0,1,1,0.5)		
	f.texture:SetTexCoord(0,1,0,1)
	f.texture:SetGradientAlpha("HORIZONTAL",1,1,1,1,1,1,1,1)
	f.texture:Hide()
	f.fontstring:Hide()
	f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
	f.fontstring:SetJustifyH("CENTER")
	f.fontstring:SetTextHeight(14)
	
	f.framelevel=0
	f:SetFrameLevel(f.framelevel)
	
	--f:SetParent(nil)
	f:SetParent(UIParent)

	if(f.animgroup~=nil) then
		f.animgroup:Stop()
		f.animgroup=nil
	end
	if(f.texture.animgroup~=nil)then
		f.texture.animgroup:Stop()
		f.texture.animgroup=nil
	end
	f:SetAlpha(1)
	
	_TRAININGGROUNDS:tremovebyval(TRAININGGROUNDS_ReusableParticleFrames.activeframes,f)	
	if(TRAININGGROUNDS_tcontains(TRAININGGROUNDS_ReusableParticleFrames.inactiveframes,f))then
		--print("WARNING: TRAININGGROUNDS_ReusableParticleFrames.inactiveframes already contains "..tostring(f))
	else
		tinsert(TRAININGGROUNDS_ReusableParticleFrames.inactiveframes,f)
	end
	
end

TRAININGGROUNDS_ReusableParticleFrames.nextframeid=0
function TRAININGGROUNDS_ReusableParticleFrames.getFrame()
	local f=tremove(TRAININGGROUNDS_ReusableParticleFrames.inactiveframes)
	if not f then
		local framename="TRAININGGROUNDS_ReusableModelFrame"..tostring(TRAININGGROUNDS_ReusableParticleFrames.nextframeid);
		f=CreateFrame("DressUpModel",framename,UIParent)
		f.id=TRAININGGROUNDS_ReusableParticleFrames.nextframeid
		f.name=framename
		f.framelevel=0
		f:SetFrameLevel(f.framelevel)		
		f:SetLight(1,0,-1,0,0,1)	
		f:Hide()
		f.texture = f:CreateTexture()
		f.texture:SetAllPoints(f)
		f.texture:SetTexture(0,1,1,0.5)		
		f.texture:Hide()
		f.fontstring=f:CreateFontString(nil, "ARTWORK")
		f.fontstring:SetAllPoints()
		f.fontstring:Hide()
		f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
		f.fontstring:SetTextHeight(14)	
		f.animgroup=nil
		f.Cleanup=TRAININGGROUNDS_ReusableParticleFrames.removeFrame
		
		
		TRAININGGROUNDS_ReusableParticleFrames.nextframeid=TRAININGGROUNDS_ReusableParticleFrames.nextframeid+1
	else
		--
	end
	tinsert(TRAININGGROUNDS_ReusableParticleFrames.activeframes,f)
	return f
end

function TRAININGGROUNDS_ReusableParticleFrames.resetAllInactiveFrames()
	local looping=true
	while looping==true do
		looping=false
		local f
		f=nil
		if(#TRAININGGROUNDS_ReusableParticleFrames.activeframes>0) then			
			f=TRAININGGROUNDS_ReusableParticleFrames.activeframes[1]
		end
		if not f then
			--
		else
			TRAININGGROUNDS_ReusableParticleFrames.removeFrame(f)
			looping=true
			if(f:GetParent()~=UIParent)then
				--print("WARNING: during force cleanup, modelframe "..tostring(f:GetName()).."'s parent is not UIParent but "..tostring(f:GetParent():GetName()).." instead")
			end
			--print("Force cleanup on ReusableModelFrames: "..#TRAININGGROUNDS_ReusableParticleFrames.activeframes.." frames remaining")
		end
	end
end

