
--TODO: find out if some race cast animations are so short because
							-- maybe they're played in slow motion

FakePlayerCharacterTitleAnimations={}

-- FakePlayerCharacter will automatically add the "die" action to the end of whatever sequence is returned here



function FakePlayerCharacterTitleAnimations.DirectedSpellcast(character)
	local sequence={}		
	tinsert(sequence,{"fadeanim",0,100})
	tinsert(sequence,{"fadein",nil,500})	
	tinsert(sequence,{"idle",nil,500})
	tinsert(sequence,{"disarm",0,0})
	tinsert(sequence,{"anim",51,2000})
	--tinsert(sequence,{"anim",53,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"FinishDirectedSpellcast")
	tinsert(sequence,{"anim",0,0})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

function FakePlayerCharacterTitleAnimations.UndirectedSpellcast(character)
	local sequence={}		
	tinsert(sequence,{"fadeanim",0,100})
	tinsert(sequence,{"fadein",nil,500})	
	tinsert(sequence,{"idle",nil,500})
	tinsert(sequence,{"disarm",0,0})
	tinsert(sequence,{"anim",52,2000})
	--tinsert(sequence,{"anim",54,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"FinishUndirectedSpellcast")
	tinsert(sequence,{"anim",0,0})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

-- don't use unarmed attack with characters who hold weapons
function FakePlayerCharacterTitleAnimations.UnarmedBasicAttack(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",25,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",16,500})	
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"UnarmedPunch")
	tinsert(sequence,{"anim",25,500})	
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

function FakePlayerCharacterTitleAnimations.OneHandBasicAttack(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",17,500})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"MainhandSlash")
	tinsert(sequence,{"anim",26,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

function FakePlayerCharacterTitleAnimations.OneHandFancyAttack(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",57,1500})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"OneHandFancyAttack")
	tinsert(sequence,{"anim",26,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.TwoHandBasicAttack1(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",27,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",18,1300})		
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"TwoHandAttack1")
	tinsert(sequence,{"anim",27,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.TwoHandBasicAttack2(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",28,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",19,1300})		
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"TwoHandAttack2")
	tinsert(sequence,{"anim",28,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

--TODO: rename 2HFancyAttack or 2HBasicAttack3
function FakePlayerCharacterTitleAnimations.TwoHandStab(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",27,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",58,1200})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"TwoHandAttack3")
	tinsert(sequence,{"anim",27,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.DualWieldFancyAttack(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",25,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})
	--tinsert(sequence,{"anim",118,1500}) 		-- this one is problematic for some races
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"DualWieldFancyAttack")
	tinsert(sequence,{"anim",25,500})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.DualWieldSlashCombo(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	--tinsert(sequence,{"anim",87,1000})	--offhand slash
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"OffhandSlash")
	--tinsert(sequence,{"anim",17,1000})	--mainhand slash
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"MainhandSlash")
	tinsert(sequence,{"anim",26,100})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.DualWieldStabCombo(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	--tinsert(sequence,{"anim",85,1000})	-- mainhand stab
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"MainhandStab")
	--tinsert(sequence,{"anim",88,1000})	-- offhand stab
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"OffhandStab")
	tinsert(sequence,{"anim",26,100})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.StealthWalk(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",119,100})
	tinsert(sequence,{"stealthfadein",nil,500})
	tinsert(sequence,{"idle",69,3000})
	tinsert(sequence,{"stealthfadeout",nil,500})
	return sequence	
end


function FakePlayerCharacterTitleAnimations.Bladestorm(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",25,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"anim",126,3100})
	tinsert(sequence,{"anim",25,100})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.BladestormKnockdown(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",25,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"anim",126,5000})
	--tinsert(sequence,{"anim",14,2000})	-- stunned
	--tinsert(sequence,{"anim",121,750})		-- knockdown
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Knockdown",750)
	tinsert(sequence,{"fadeout",nil,500})
	return sequence		
end

function FakePlayerCharacterTitleAnimations.TankBlock(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})	
	--tinsert(sequence,{"anim",9,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"StanceDamage")
	--tinsert(sequence,{"anim",22,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"ShieldBlock")
	tinsert(sequence,{"anim",27,500})	
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

function FakePlayerCharacterTitleAnimations.TankDodge(character)
	local sequence={}	
	tinsert(sequence,{"fadeanim",26,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})	
	--tinsert(sequence,{"anim",9,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"StanceDamage")
	--tinsert(sequence,{"anim",21,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Parry")
	--tinsert(sequence,{"anim",30,1000})
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Dodge")
	tinsert(sequence,{"anim",26,500})	
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end



-- TODO LATER: ranged bow animations, in case we ever add bows to ranged title costumes

function FakePlayerCharacterTitleAnimations.HunterGunshot(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",110,100})	-- hunter gun stance
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,1000})		-- 
	--tinsert(sequence,{"anim",49,1000})		-- fire gun
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"FireGun")
	--tinsert(sequence,{"anim",106,500})		-- ready gun
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"ReloadGun")
	-- TODO: set a final sequence we can change to DURING fadeout	
	tinsert(sequence,{"anim",110,1})		-- hunter gun stance
	tinsert(sequence,{"fadeout",nil,500})
	return sequence	
end

function FakePlayerCharacterTitleAnimations.HunterDisengage(character)
	local sequence={}
	--tinsert(sequence,{"fadeanim",13,100})	-- walk backwards
	tinsert(sequence,{"fadeanim",110,100})	-- hunter gun stance
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,500})		-- 
	--tinsert(sequence,{"anim",37,400})		-- jump
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Jump")
	tinsert(sequence,{"anim",38,750})		-- midair
	--tinsert(sequence,{"anim",39,750})		-- land
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"LandOnGround",750)
	tinsert(sequence,{"anim",13,500})		-- walk backwards
	tinsert(sequence,{"fadeout",nil,500})
	return sequence	
end


function FakePlayerCharacterTitleAnimations.HunterKnockdown(character)
	local sequence={}
	tinsert(sequence,{"fadeanim",110,100})	-- hunter gun
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",nil,1000})		-- 
	tinsert(sequence,{"anim",49,150})		-- fire gun
	--tinsert(sequence,{"anim",121,1500})		-- knockdown
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Knockdown",1400)
	tinsert(sequence,{"fadeout",nil,500})
	return sequence	
end


function FakePlayerCharacterTitleAnimations.MonkCombo(character)
	local sequence={}
	tinsert(sequence,{"disarm",nil,0})
	tinsert(sequence,{"fadeanim",678,100})	--monk stance
	tinsert(sequence,{"fadein",nil,500})	
	--tinsert(sequence,{"anim",670,1000})	-- tiger palm
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"TigerPalm")
	--tinsert(sequence,{"anim",662,1000})	-- BoK
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"BlackoutKick")
	--tinsert(sequence,{"anim",736,1000})	-- RSK
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"RisingSunKick")
	tinsert(sequence,{"anim",678,100})	-- monk stance
	tinsert(sequence,{"fadeout",nil,500})	
	return sequence
end

function FakePlayerCharacterTitleAnimations.MonkRoll(character)
	local sequence={}
	
	tinsert(sequence,{"disarm",nil,0})	
	tinsert(sequence,{"fadeanim",5,110})	-- run forward
	tinsert(sequence,{"fadein",nil,500})

	tinsert(sequence,{"anim",664,550})		-- start roll
	tinsert(sequence,{"anim",666,330})		-- roll loop
	-- tinsert(sequence,{"seq",666,280*4,0.25})
	tinsert(sequence,{"anim",668,150})		-- end roll into run
	tinsert(sequence,{"anim",5,500})		-- run forward

	-- --TODO LATER: if we use the hunter animation as a rare easter egg for other classes,
		-- -- add a "pshew pshew" not-quite-speech-bubble to the character
		-- -- (hunter animation works well on staff classes -- priest/druid/mage/warlock)

	-- -- TODO: set a final sequence we can change to DURING fadeout
	
	tinsert(sequence,{"fadeout",nil,500})	
	
	return sequence
end



function FakePlayerCharacterTitleAnimations.SwimForward(character)
	local sequence={}
	tinsert(sequence,{"disarm",nil,0})	
	tinsert(sequence,{"fadeanim",42,100})
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",69,3000})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence	
end

function FakePlayerCharacterTitleAnimations.FlexDie(character)
	local sequence={}
	tinsert(sequence,{"disarm",nil,0})	
	tinsert(sequence,{"fadein",nil,500})
	--tinsert(sequence,{"anim",82,2000})	-- flex
													--TODO: make sure limit of 6000 looks okay for goblin F
	FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence,"Flex",6000)
	tinsert(sequence,{"anim",1,3000})	
	tinsert(sequence,{"fadeout",nil,500})
	return sequence	
end


function FakePlayerCharacterTitleAnimations.Dance(character)
	local sequence={}
	tinsert(sequence,{"disarm",nil,0})	
	tinsert(sequence,{"fadeanim",69,100})	-- dance
	tinsert(sequence,{"fadein",nil,500})
	tinsert(sequence,{"idle",69,7000})
	tinsert(sequence,{"fadeout",nil,500})
	return sequence
end

function FakePlayerCharacterTitleAnimations.InsertRaceSpecificAnim(character,sequence, name,limit)
	local race=character.displayedrace
	local sex=character.displayedsex
	local index,duration=TRAININGGROUNDS_PlayerAnimations.GetDetailsForNamedAnimation(name,race,sex)
	if(limit~=nil)then
		if(duration>limit)then duration=limit end
	end
	--print("InsertRaceSpecificAnim... ",name," ",race,sex,duration)
	tinsert(sequence,{"anim",index,duration})
end