TRAININGGROUNDS_Particle_ChiBurst = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Particle)

function TRAININGGROUNDS_Particle_ChiBurst:SetCustomInfo()
	TRAININGGROUNDS_Particle.SetCustomInfo(self)
	
	-- struck targets have invincibility frames.
	-- it is possible to hit the same enemy twice, if the enemy is moving very quickly.
	-- TODO: this is more likely if the framerate is very low, which is unintended
	-- iframes[obj] = time when obj's iframes expire.
	self.iframes={}
	self.hitdetectfrequency=250
	self.nexthitdetecttick=self.environment.currenttime+self.hitdetectfrequency
end

function TRAININGGROUNDS_Particle_ChiBurst:SetModelSpecificInfo()
	self.modelframe:SetModel(0)
	self.modelframe:SetModel("SPELLS\\Monk_ChiBlast_Missile.M2")	
	self.modelframe:SetWidth(50)
	self.modelframe:SetHeight(50)
	--self.modelframe:SetPosition(-4,0,2.6)	-- for normal window
	--self.modelframe:SetPosition(0,0,0)
	self.modelinfo.sideviewoffsetY=100
	self.modelinfo.sideviewclickheight=0
	self.modelinfo.topviewoffsetY=100
	self.modelinfo.clickwidth=0
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=0.15
end

function TRAININGGROUNDS_Particle_ChiBurst:step(elapsed)
	TRAININGGROUNDS_Particle.step(self,elapsed)
	
	-- beginning of the line segment for line-circle hit detection.
	-- after we run hit detection, the beginning of the line segment moves up to projectile's current position.
	if(self.xsegmentstart==nil)then
		self.xsegmentstart=self.xstart
		self.ysegmentstart=self.ystart
	end
	
	if(self.expirytime==nil)then
		local distsqr=(self.x-self.xstart)*(self.x-self.xstart)+(self.y-self.ystart)*(self.y-self.ystart)
		--TODO: standardize "40 yards"
		if(distsqr>800*800)then
			self.xspeed=0;self.yspeed=0
			self.expirytime=self.environment.currenttime+250
			-- also immediately run hit detection again, since we don't do that once expirytime kicks in
			self.nexthitdetecttick=0
		end
	
		if(self.environment.currenttime>=self.nexthitdetecttick)then
			self.nexthitdetecttick=self.environment.currenttime+self.hitdetectfrequency
			-- spell is set via Spell_ChiBurst
			local radius=50 --!!!
			local objlist=self.spell.combat.character.environment:LineCircleCollisionList(self.xsegmentstart,self.ysegmentstart,self.x,self.y,radius)
			self.xsegmentstart=self.x;self.ysegmentstart=self.y
			local wowlist={}
			local i
			for i=1,#objlist,1 do
				local obj=objlist[i]
				if(obj.combat~=nil)then
					--TODO: not isa
					if(obj:isa(TRAININGGROUNDS_Enemy))then		
					
						if(self.iframes[tostring(obj)]==nil or self.iframes[tostring(obj)]<=self.environment.currenttime)then
							tinsert(wowlist,obj)
						end
					end
				end
			end
			if(self.spell~=nil)then
				for i=1,#wowlist,1 do
					local obj=wowlist[i]
					self.iframes[tostring(obj)]=self.environment.currenttime+self.hitdetectfrequency*2
					self.spell:OnProjectileHit(currenttime,obj)
				end
			end
		end

	else
		local a=(self.expirytime-self.environment.currenttime)/250
		self.modelframe:SetAlpha(a)
	end


	
	
	
end