TRAININGGROUNDS_Pet_SEF = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_WoWCharacter)

-- BEFORE calling setup:
	-- set sefindex to 1 or 2 


function TRAININGGROUNDS_Pet_SEF:SetCustomInfo()
	TRAININGGROUNDS_WoWCharacter.SetCustomInfo(self)
	
	self.framecount=0
	self.animationindex_superfastrun=702	--pseudo-SCK
end

function TRAININGGROUNDS_Pet_SEF:SetClickability()
	-- don't call super
	self.clickable=false	
	-- --self.clickable=true
	self.clickarea={}
	self.clickarea.x=0*4; self.clickarea.y=0*4; self.clickarea.width=15*4; self.clickarea.height=15*4
end

function TRAININGGROUNDS_Pet_SEF:SetCombat()
	self.combat=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk_SEF.new()
	self.combat:setup(self)
	self.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP)
	self.combat:CreateSpellButtons()
	self.copyownerstarget=false
	self.focustarget=nil
end

function TRAININGGROUNDS_Pet_SEF:CopyChiOrbit()
	--already checked if we're using Chi Orbit
	-- call this on frame step event after combat step event.  can't call any earlier because our own CO buff is still in the newbuff queue
							-- ...while it might be possible to get around that, it's probably messy to do so
	
	local ownerco=self.owner.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit)
	local myco=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit)
	--these buff had better exist, most likely crash if they're missing...
	--print("CopyChiOrbit")
	for o=1,4,1 do
		if(not (ownerco.orbs[o]==nil or ownerco.orbs[o].dead==true))then
			--print("Orb ",o)
			local orb=TRAININGGROUNDS_Particle_ChiOrbit.new()
			orb:setup(self.combat.character.environment)
			orb.character=self
			orb.x=self.x
			orb.y=self.y
			orb.z=50	--TODO: possibly change chiburst.z to 50 too
			orb.orbitradius=ownerco.orbs[o].orbitradius
			orb.gravity=0
			local speed=875	
			orb.cangooob=true
			orb.buff=myco
			orb.slot=o
			-- temporary: reduce orbitradius so projectiles have a better chance at hitting vs single target
			-- (TODO:)
			orb.maxorbitradius=100--200
			if(orb.orbitradius>orb.maxorbitradius)then orb.orbitradius=orb.maxorbitradius end
			myco.orbs[o]=orb
		end
	end
	myco.angle=ownerco.angle
	myco.nextticktime=ownerco.nextticktime
	--print("CopyCO ",myco,myco.angle)
	
end

function TRAININGGROUNDS_Pet_SEF:SetModelSpecificInfo()
	-- -- Reminder to self that under certain conditions, calling SetCustomRace()
	-- -- is potentially a violation of the World of Warcraft User Interface Add-On Development Policy.
	-- do not call super
	self.modelinfo={}
	local modelinfo,race,sex=TRAININGGROUNDS_PlayerCharacterModelInfo.SetModelframeToPlayerAndReturnModelInfo(self.modelframe)
	self.modelinfo=modelinfo
	self.race=race
	self.sex=sex
	--TODO: ask environment or game if we're using any custom equipment
	self.equipment=TRAININGGROUNDS_PlayerCharacterModelInfo.GetPlayerDefaultEquipment()
	-- monks:
	self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["MainHandSlot"]]=nil	
	self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["SecondaryHandSlot"]]=nil	
	-- for now, just set equipment to nil to avoid hidehelm/hidecape problems
	self.equipment=nil
	local customrace=nil
	local customsex=nil
	if(customrace~=nil)then self.race=customrace end
	if(customsex~=nil)then self.sex=customsex end	
	self.modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(self.modelframe,self.equipment,customrace,customsex)
	
	if(self.sefindex==1)then
		--TODO: brewmaster keg for green sef (if possible)				
		self.modelframe:SetLight(1,0,-1,0,0, 4.0, 0.25,0.25,1, 0,1,1,1)
		self.modelframe:SetAlpha(0.75)
		self.modelframe:TryOn(90844)
		self.modelframe:TryOn(25197)
		self.modelframe:TryOn(25197)
	elseif(self.sefindex==2)then
		self.modelframe:SetLight(1,0,-1,0,0, 4.0, 1,0.25,0.25, 0,1,1,1)
		self.modelframe:SetAlpha(0.75)				
		self.modelframe:TryOn(83649)
		self.modelframe:TryOn(82059)
		self.modelframe:TryOn(82059)
	else
		--TODO: debug warning
	end
end



function TRAININGGROUNDS_Pet_SEF:step(elapsed)
	TRAININGGROUNDS_WoWCharacter.step(self,elapsed)
	
	local currenttime=self.environment.currenttime

	self.framecount=self.framecount+1
	if(self.framecount==2)then
		--only try this once, on the 2nd frame, after chiorbit is moved out of the newbuff list to the main buff list
		local co=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit)
		if(co~=nil)then
			self:CopyChiOrbit()
		end
	end
	
	if(self.combat.target~=nil)then
		if(self.combat.target.deadingame==true)then
			self.combat:ChangeTarget(nil)
		end
	end
	
	if(self.combat.target==nil)then
		--self.combat:ChangeTarget(self.owner.combat.target)
		self.focustarget=nil
	end
	
	
	if(self.acquirenewtargetnextframe==true)then
		--local scktargets=self.combat:GetSCKTargetList()
		--print("SEF #",self.sefindex,"'s old target: ",self.combat.target," time: ",scktargets[tostring(self.combat.target)])
		self:AcquireNewTarget()
		--print("SEF #",self.sefindex,"'s new target: ",self.combat.target," time: ",scktargets[tostring(self.combat.target)])
		self.acquirenewtargetnextframe=false
	end
	
	if(self.combat.target==nil)then
		-- can't acquire new target this frame
		-- if there's only one enemy left,
		-- SEFs will try to switch to each others targets
		-- and this will sustain the dead target forever	
		self.acquirenewtargetnextframe=true
		-- make sure to set this AFTER the above check...
	end
	
	
	local movex,movey,facing=self:GetMoveLocation(self.combat.target)
	self:PetMoveTo(movex,movey,facing,elapsed)

	
	if(self.expirytime~=nil)then
		local a=(self.expirytime-currenttime)/1000.0
		if(a>1)then 
			a=1 
		else
			self.modelframe:SetAlpha(a)
		end
	end
end



function TRAININGGROUNDS_Pet_SEF:AcquireNewTarget()

	local scktargets=self.combat:GetSCKTargetList()

	-- first narrow the list of objects down to all possible targets except owner's target
	local objs=self.environment.gameobjects
	local objs2={}
	for i=1,#objs,1 do		
		local obj=objs[i]
		--TODO:
		if(obj:isa(TRAININGGROUNDS_Enemy))then
			--TODO: check for 90%+ DR (not an issue until shas are implemented...)
			--TODO: check if enemy is in combat with us
			--TODO: check hard CC
			if(obj.deadingame~=true)then		
				if(self.owner.combat.target~=obj)then
					tinsert(objs2,obj)
				end
			end
		end
	end	
	-- list of all possible targets
	local remainingtargets=objs2
	objs={}

	-- special exception:
	-- if there are exactly 2 targets available (3 including player's target)
	-- and we are SEF#1,
	-- and we're not attacking player's target,
	-- don't change targets if we already have a target
	-- otherwise SEF#2 will just fill in our spot
	if(#remainingtargets==2 and self.sefindex==1)then
		if(self.combat.target~=nil and self.combat.target~=self.owner.combat.target)then
			return
		end
	end

	local othersef=self.spell.sefs[self:GetOtherSEFIndex()]	
	
	-- from those targets, make a list of objects that are either
		-- 1. not on the SCK list, or
		-- 2. on the SCK list, but already expired
	local expiredtargets={}	
	for i=#remainingtargets,1,-1 do
		local obj=remainingtargets[i]
		if(othersef.combat.target~=obj)then
			if(scktargets[tostring(obj)]==nil or scktargets[tostring(obj)]<self.environment.currenttime)then			
				tinsert(expiredtargets,obj)
				tremove(remainingtargets,i)
			end
		end
	end
		
	-- get the closest object
	target=self:GetClosestFromList(expiredtargets)

	-- if we have a target, break
	if(target~=nil)then
		self.combat.target=target
		return
	end
		
	--otherwise run through the list of remaining targets again and look for the enemy(ies) with the lowest time
	objs2={}
	local lowesttime=nil
	for i=1,#remainingtargets,1 do
		local obj=remainingtargets[i]
		if(othersef.combat.target~=obj)then
			if(lowesttime==nil or scktargets[tostring(obj)]<=lowesttime)then
				if(lowesttime~=nil and scktargets[tostring(obj)]<lowesttime)then
					objs2={}
				end
				tinsert(objs2,obj)
				lowesttime=scktargets[tostring(obj)]
			end
		end
	end
	
	-- get the closest object
	target=self:GetClosestFromList(objs2)	
	if(target~=nil)then
		--print("Switching to ",target)
		self.combat.target=target
		return
	end
	-- if we still don't have a target, try to target whatever othersef is targeting
	if(othersef.combat.target~=nil)then
		--print("Switching to othersef's target, which is ", othersef.combat.target)
		if(othersef.combat.target.deadingame~=true)then
			self.combat.target=othersef.combat.target
			return
		end		
	end
	-- otherwise target owner's target	
	--print("Switching to owner's target")
	self.combat.target=self.owner.combat.target	--target may still be nil
	if(self.combat.target~=nil)then
		if(self.combat.target.deadingame==true)then
			--print("Target is dead, so switching to nil")
			self.combat.target=nil
		end
	end
end


function TRAININGGROUNDS_Pet_SEF:GetClosestFromList(list)
	local target=nil
	local mindistsqr=nil
	local objs=list
	for i=1,#objs,1 do		
		local obj=objs[i]
		local distsqr=(self.x-obj.x)*(self.x-obj.x)+(self.y-obj.y)*(self.y-obj.y)
		if(mindistsqr==nil or distsqr<mindistsqr)then
			mindistsqr=distsqr
			target=obj
		end
	end	
	return target
end

-- if owner isn't targeting anything, pet target remains unchanged
function TRAININGGROUNDS_Pet_SEF:TryTargetOwnersTarget()
	-- if(self.owner.combat.target~=nil)then
		-- if(self.owner.combat.target.deadingame~=true)then
			-- self.combat:ChangeTarget(self.owner.combat.target)
		-- end
	-- end	
end


function TRAININGGROUNDS_Pet_SEF:GetMoveLocation(target)	
	local movetarget,movetargetangle,distance
	if(target==nil)then
		self.petmovespeedmultiplier=1.0
		movetarget=self.owner		
		movetargetangle=(self.owner.currentfacing-math.pi/2)+(math.pi*2)*((2*self.sefindex)/6.0)
		distance=150
	else
		self.petmovespeedmultiplier=4.1
		movetarget=target		
		movetargetangle=(movetarget.currentfacing-math.pi/2)+(math.pi*2)*((2*self.sefindex)/6.0)
		distance=100
	end
	
	-- can't FSK while FoFing...
	if(self.combat.channeledspell~=nil)then self.petmovespeedmultiplier=1.0 end
	
	local movex,movey
	movex=movetarget.x+math.cos(movetargetangle)*distance
	movey=movetarget.y+math.sin(movetargetangle)*distance
	return movex,movey,movetarget.currentfacing
end

--for use when target==nil
function TRAININGGROUNDS_Pet_SEF:GetPetMoveMultiplier(x,y)
	local result
	local distancetotarget=math.sqrt((x-self.x)*(x-self.x)+(y-self.y)*(y-self.y))
	local mindist=20
	local maxdist=400
	result=0.5+((distancetotarget-mindist)/(maxdist-mindist))*3.1
	if(distancetotarget<=20)then
		result=0.5
	end
	if(distancetotarget>=400)then
		result=4.1
	end
	-- can't FSK while FoFing...
	if(self.combat.channeledspell~=nil and result>1.0)then result=1.0 end
	return result
end

--for use when FSKing between targets
function TRAININGGROUNDS_Pet_SEF:GetPriorityPetMoveMultiplier(x,y)
	local result
	local distancetotarget=math.sqrt((x-self.x)*(x-self.x)+(y-self.y)*(y-self.y))
	local mindist=20
	local maxdist=400
	result=0.5+((distancetotarget-mindist)/(maxdist-mindist))*3.1
	if(distancetotarget<=20)then
		result=0.5
	end
	if(distancetotarget>=400)then
		result=4.1
	end
	-- can't FSK while FoFing...
	if(self.combat.channeledspell~=nil and result>1.0)then result=1.0 end
	return result
end

function TRAININGGROUNDS_Pet_SEF:PetMoveTo(x,y,facing,elapsed)
	--TODO: we might not be using facing anymore
	if(self.petmovespeedmultiplier==nil)then
		--TODO: debug warning
		self.petmovespeedmultiplier=1
	end
	
	local targetx,targety=x,y
	local moveangle=math.atan2(targety-self.y,targetx-self.x)
		
	if(self.target==nil)then
		self.petmovespeedmultiplier=self:GetPetMoveMultiplier(targetx,targety)
	else
		self.petmovespeedmultiplier=self:GetPriorityPetMoveMultiplier(targetx,targety)
	end
	
	--TODO: don't directly set xspeed/yspeed	
	local MOVESPEED=TRAININGGROUNDS_Game.TEMP_MOVESPEED*self.petmovespeedmultiplier
	
	local distancetotarget=math.sqrt((targetx-self.x)*(targetx-self.x)+(targety-self.y)*(targety-self.y))
	--print(distancetotarget)
	--if(distancetotarget>20*self.petmovespeedmultiplier) then	
	--if(distancetotarget>50) then	
	if(distancetotarget>20) then
		self.xspeed=math.cos(moveangle)*MOVESPEED
		self.yspeed=math.sin(moveangle)*MOVESPEED
	
		self.movevectorxx=self.xspeed
		self.movevectoryy=self.yspeed
		--self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
		self.movespeed=self.petmovespeedmultiplier
		local turnspeed=1
		local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy)	
		self:changeFacing(movevectorfacing,elapsed,turnspeed)
	else
		self.movevectorxx=0
		self.movevectoryy=0
		self.movespeed=0
		self.xspeed=0
		self.yspeed=0
		local turnspeed=1
		local facing2
		if(self.combat.target~=nil)then
			-- if(self.combat.target==self.owner)then
				-- print("have target, but target is owner")
			-- end
			
			facing2=math.atan2(self.combat.target.y-self.y,self.combat.target.x-self.x)+math.pi/2
		else
			facing2=self.owner.currentfacing
		end
		self:changeFacing(facing2,elapsed,turnspeed)
	end
end

function TRAININGGROUNDS_Pet_SEF:GetOtherSEFIndex()
	if(self.sefindex==1)then
		return 2
	else
		return 1
	end
end

-- -- SOURCE: lua-users.org/wiki/CopyTable
-- --TODO: move to TrainingGrounds.lua
-- function TRAININGGROUNDS_shallowcopy(orig)
    -- local orig_type = type(orig)
    -- local copy
    -- if orig_type == 'table' then
        -- copy = {}
        -- for orig_key, orig_value in pairs(orig) do
            -- copy[orig_key] = orig_value
        -- end
    -- else -- number, string, boolean, etc
        -- copy = orig
    -- end
    -- return copy
-- end

function TRAININGGROUNDS_Pet_SEF:Cleanup()
	--TODO: move self.spell.sefs cleanup to SEF buff
		-- and do something similar for xuen (requires implementing an invisible xuen buff)
	TRAININGGROUNDS_WoWCharacter.Cleanup(self)
	if(self.spell.sefs[self:GetOtherSEFIndex()].dead==true)then
		self.spell.sefs={}
	end	
end