TRAININGGROUNDS_Xuen = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_WoWCharacter)

-- Target: 30% of Huge Illusionary Slayer within 45 seconds
		--(10% per 15 seconds)
-- Current: 100+% of Huge Illusionary Slayer
--TRAININGGROUNDS_Xuen.TEMP_NERF_MULTIPLIER=33.0/100.0	--results in 33% damage
TRAININGGROUNDS_Xuen.TEMP_NERF_MULTIPLIER=0.275		--close enough
	-- need to take into account enemy hp multiplier too, if that changes


	
function TRAININGGROUNDS_Xuen:SetCustomInfo()
	TRAININGGROUNDS_WoWCharacter.SetCustomInfo(self)
	
	self.aadamage=174*TRAININGGROUNDS_Xuen.TEMP_NERF_MULTIPLIER
	self.aoedamage=260*TRAININGGROUNDS_Xuen.TEMP_NERF_MULTIPLIER

	--self.animationindex_superfastrun=38	--pseudo-leap
	-- not using leap for now, looks awkward (or moreso than normal fastrun)
	--also setting SFR and FR to normal run so the animation doesn't try to cut into itself
	self.animationindex_superfastrun=self.animationindex_run
	self.animationindex_fastrun=self.animationindex_run
		
end

function TRAININGGROUNDS_Xuen:SetClickability()
	-- don't call super
	self.clickable=false	
	-- --self.clickable=true
	self.clickarea={}
	self.clickarea.x=0*4; self.clickarea.y=0*4; self.clickarea.width=15*4; self.clickarea.height=15*4
end

function TRAININGGROUNDS_Xuen:SetCombat()
	self.combat=TRAININGGROUNDS_CombatModule.new()
	self.combat:setup(self)
	self.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP)
	--!!!
	self.copyownerstarget=true
end


function TRAININGGROUNDS_Xuen:SetModelSpecificInfo()
	-- Xuen
	self.modelframe:SetDisplayInfo(49236)
	self.modelinfo.sideviewoffsetY=110
	self.modelinfo.sideviewclickheight=120
	self.modelinfo.topviewoffsetY=0
	self.modelinfo.clickwidth=200
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=1
		
		

end


function TRAININGGROUNDS_Xuen:step(elapsed)
	TRAININGGROUNDS_WoWCharacter.step(self,elapsed)
	
	
	
	if(self.combat.target~=nil)then
		if(self.combat.target.deadingame==true)then
			self.combat:ChangeTarget(nil)			
			self:AcquireNewTarget()
		end
	end
	
	if(self.combat.target==nil)then
		--self.combat:ChangeTarget(self.owner.combat.target)
		self:TryTargetOwnersTarget()
	end
	
	--currently, xuen will only copy player target if he doesn't already have a target
	-- (TODO:)


	local movex,movey,facing=self:GetMoveLocation(self.combat.target)
	self:PetMoveTo(movex,movey,facing,elapsed)

	self.outofrangethisframe=false
	--TODO: convert to actual Spell object
	local currenttime=self.environment.currenttime	
	if(self.nextattacktime==nil or self.environment.currenttime>=self.nextattacktime)then
		-- every 600ms with heroism, so ... 780?
		if(self.combat.target~=nil)then
			--range check
			local distsqr=(self.x-self.combat.target.x)*(self.x-self.combat.target.x)+(self.y-self.combat.target.y)*(self.y-self.combat.target.y)
			if(distsqr<200*200)then
				self.nextattacktime=currenttime+780
				self:SetAnimationByIndex(662,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,1000,true)
				self.combat:ApplyDamageToEnemy(self.aadamage,self.combat.target)
				--print("Xuen AA, target remaining HP: ",100*self.combat.target.combat.hp.value/self.combat.target.combat.hp.max,"%")
			else
				self.outofrangethisframe=true
				--print("Xuen is out of range of target")
			end
		end
	end
	if(self.nextlightningtime==nil or self.environment.currenttime>=self.nextlightningtime)then
		--"10 yards" (SCK is 8 yards)
		local maxradius=300*(10/8)
		local objlist=self.environment:PointCircleCollisionList(self.x, self.y, 1, maxradius)
		local wowlist={}
		local i
		for i=1,#objlist,1 do
			local obj=objlist[i]
			if(obj.combat~=nil)then
				--TODO: not isa
				if(obj:isa(TRAININGGROUNDS_Enemy))then		
					tinsert(wowlist,obj)
				end
			end
		end		
		-- AOE only hits 3 enemies at a time
		--TODO: move to TrainingGrounds.lua
		--TODO: implement shuffle at SOURCE: stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
		local shuffle=function(unshuffled)
			local length=#unshuffled
			local shuffled={}
			local i
			for i=1,length,1 do
				local j=random(#unshuffled)
				tinsert(shuffled,unshuffled[j])
				tremove(unshuffled,j)
			end
			return shuffled
		end
		wowlist=shuffle(wowlist)
		local m=min(#wowlist,3)
		for i=1,m,1 do
			local obj=wowlist[i]
			self.combat:ApplyDamageToEnemy(self.aoedamage,obj,self)	
			--print("Xuen AOE, target remaining HP: ",100*obj.combat.hp.value/obj.combat.hp.max,"%")
		end
		self.nextlightningtime=currenttime+1000
		
	end
	
	
	local a=(self.expirytime-currenttime)/1000.0
	if(a>1)then 
		a=1 
	else
		self.modelframe:SetAlpha(a)
	end
	
end



function TRAININGGROUNDS_Xuen:AcquireNewTarget()
	if(self.copyownerstarget==true)then
		--self.combat:ChangeTarget(self.owner.combat.target)
		self:TryTargetOwnersTarget()
		return
	end
	--if(self.combat.target~=nil)then return end
	
	local target=nil
	local mindistsqr=nil
	local objs=self.environment.gameobjects
	for i=1,#objs,1 do		
		local obj=objs[i]
		--TODO:
		if(obj:isa(TRAININGGROUNDS_Enemy))then
			--TODO: check for 90%+ DR (not an issue until shas are implemented...)
			--TODO: check if enemy is in combat with us
			if(obj.deadingame~=true)then
				local distsqr=(self.x-obj.x)*(self.x-obj.x)+(self.y-obj.y)*(self.y-obj.y)
				if(mindistsqr==nil or distsqr<mindistsqr)then
					mindistsqr=distsqr
					target=obj
				end
			end
		end
	end
	self.combat.target=target	--target may still be nil
end

-- if owner isn't targeting anything, pet target remains unchanged
function TRAININGGROUNDS_Xuen:TryTargetOwnersTarget()
	if(self.owner.combat.target~=nil)then
		if(self.owner.combat.target.deadingame~=true)then
			self.combat:ChangeTarget(self.owner.combat.target)
		end
	end	
end


function TRAININGGROUNDS_Xuen:GetMoveLocation(target)	
	local movetarget,movetargetangle
	if(target==nil)then
		self.petmovespeedmultiplier=1.0
		movetarget=self.owner
		--movetargetangle=(self.owner.currentfacing-math.pi/2)+(math.pi*2)*(2/6.0)
		movetargetangle=(self.owner.currentfacing-math.pi/2)+(math.pi*2)*(1/4.0)
	else
		self.petmovespeedmultiplier=4.1
		movetarget=target		
		movetargetangle=(movetarget.currentfacing-math.pi/2)+(math.pi*2)*(1/2.0)
		--print(movetarget,"!")
	end
	local movex,movey
	movex=movetarget.x+math.cos(movetargetangle)*150
	movey=movetarget.y+math.sin(movetargetangle)*150
	return movex,movey,movetarget.currentfacing
end

function TRAININGGROUNDS_Xuen:GetPetMoveMultiplier(x,y)
	local result
	local distancetotarget=math.sqrt((x-self.x)*(x-self.x)+(y-self.y)*(y-self.y))
	local mindist=20
	local maxdist=400
	result=0.5+((distancetotarget-mindist)/(maxdist-mindist))*3.1
	if(distancetotarget<=20)then
		result=0.5
	end
	if(distancetotarget>=400)then
		result=4.1
	end
	return result
end

function TRAININGGROUNDS_Xuen:PetMoveTo(x,y,facing,elapsed)
	--TODO: we might not be using facing anymore
	if(self.petmovespeedmultiplier==nil)then
		--TODO: debug warning
		self.petmovespeedmultiplier=1
	end
	
	local targetx,targety=x,y
	local moveangle=math.atan2(targety-self.y,targetx-self.x)
	
	self.petmovespeedmultiplier=self:GetPetMoveMultiplier(targetx,targety)
	
	--TODO: don't directly set xspeed/yspeed	
	local MOVESPEED=TRAININGGROUNDS_Game.TEMP_MOVESPEED*self.petmovespeedmultiplier
	
	local distancetotarget=math.sqrt((targetx-self.x)*(targetx-self.x)+(targety-self.y)*(targety-self.y))
	--print(distancetotarget)
	--if(distancetotarget>20*self.petmovespeedmultiplier) then	
	--if(distancetotarget>50) then	
	if(distancetotarget>20) then	
		self.xspeed=math.cos(moveangle)*MOVESPEED
		self.yspeed=math.sin(moveangle)*MOVESPEED
	
		self.movevectorxx=self.xspeed
		self.movevectoryy=self.yspeed
		--self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
		self.movespeed=self.petmovespeedmultiplier
		local turnspeed=1
		local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy)	
		self:changeFacing(movevectorfacing,elapsed,turnspeed)
	else
		--print("Xuen is too close to target to move: distance",distancetotarget)
		self.movevectorxx=0
		self.movevectoryy=0
		self.movespeed=0
		self.xspeed=0
		self.yspeed=0
		local turnspeed=1
		local facing2
		if(self.combat.target~=nil)then
			facing2=math.atan2(self.combat.target.y-self.y,self.combat.target.x-self.x)+math.pi/2
		else
			facing2=self.owner.currentfacing
		end
		self:changeFacing(facing2,elapsed,turnspeed)
	end
end

function TRAININGGROUNDS_Xuen:Cleanup()	
	TRAININGGROUNDS_WoWCharacter.Cleanup(self)
	self.spell.xuen=nil
end