TRAININGGROUNDS_Equipment = {}
TRAININGGROUNDS_Equipment.__index = TRAININGGROUNDS_Equipment

TRAININGGROUNDS_Equipment.invtype={}
TRAININGGROUNDS_Equipment.invtype["INVTYPE_CHEST"]="ChestSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_FEET"]="FeetSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_HAND"]="HandsSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_HEAD"]="HeadSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_LEGS"]="LegsSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_ROBE"]="ChestSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_SHOULDER"]="ShoulderSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_WAIST"]="WaistSlot"
TRAININGGROUNDS_Equipment.invtype["INVTYPE_WRIST"]="WristSlot"


function TRAININGGROUNDS_Equipment.new()
	local self=setmetatable({}, TRAININGGROUNDS_Equipment)	
		
	self.items={}
		
	return self
end

function TRAININGGROUNDS_Equipment:EquipItemToKnownSlot(itemid, slotstring)
	local slotid=TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID[slotstring]
	if(slotid==nil)then
		print("TRAININGGROUNDS_Equipment:EquipItemToKnownSlot warning: "..slotstring.." isn't a known equipment slot")
	end
	self.items[slotid]=itemid
end

function TRAININGGROUNDS_Equipment:TryItem(itemid)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemid)
	if(itemName==nil)then
		-- Item hasn't been cached yet!
		-- Character will have to try calling again later.
		return false
	end
	
	--print("Item "..itemid.." equippable in "..tostring(itemEquipLoc))
	if(itemEquipLoc=="") then 
		print("Itemid can't be equipped: "..itemid); 
		return false
	end
	local slotname=TRAININGGROUNDS_Equipment.invtype[itemEquipLoc]
	if(slotname==nil)then
		print("Equipment.lua Unknown equipment slot name "..tostring(slotname).." for itemEquipLoc "..tostring(itemEquipLoc).." for item "..itemid)
		return false
	end
	local slotid=TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID[slotname]
	if(slotid==nil)then
		--print("Equipment.lua Unknown slot id: "..tostring(slotid).." ("..slotname..")")
		return false
	end
	--print("Equipping "..itemid.." to slot "..slotid)
	self.items[slotid]=itemid
	
	return true
end