TRAININGGROUNDS_PlayerCharacter = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_WoWCharacter)



function TRAININGGROUNDS_PlayerCharacter:setup(game)
	TRAININGGROUNDS_WoWCharacter.setup(self,game)

end 

function TRAININGGROUNDS_PlayerCharacter:SetCustomInfo()
	TRAININGGROUNDS_WoWCharacter.SetCustomInfo(self,game)

	self.idleanimindex=0	
	
	--this will be assigned by pausemenu's step event
	-- we have to keep track from here due to potential race conditions with our cleartarget
	-- (i.e. the same keypress could cleartarget AND open the pause menu)
	-- (or the same keypress could close AND open the menu)
	self.pausemenucontroller=nil
end

function TRAININGGROUNDS_PlayerCharacter:SetCombat()
	-- self.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new()
	-- self.combat:setup(self)
	-- self.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP) -- 6.2 PTR
	-- --self.combat:CreateVisibleFrames()
	-- --self.combat:CreateSpellButtons()
	-- self.combat:CreateTutorialSpellButtons(1)
end

function TRAININGGROUNDS_PlayerCharacter:SetClickability()	
	TRAININGGROUNDS_WoWCharacter.SetClickability(self)
	self.clickable=false
	
	if(_TRAININGGROUNDS.debug_playerisclickable==true)then
		self.clickable=true
	end
	
	-- self.clickable=true
	-- self.clickarea={}
	-- --self.clickarea.x=0; self.clickarea.y=-17; self.clickarea.width=23; self.clickarea.height=36		--Pandaren M
	-- --self.clickarea.x=0; self.clickarea.y=-17; self.clickarea.width=self.modelwidth; self.clickarea.height=36		--Pandaren M
	-- self.clickarea.x=0
	-- --self.clickarea.y=-(self.modelwidth/2)*(math.abs(self.environment.camera.modelangle)/(math.pi/2))
	-- self.clickarea.y=-0.5*self.modelwidth*(-math.sin(self.environment.camera.modelangle))
	
	-- self.clickarea.width=self.modelwidth
-- --	self.clickarea.height=(self.modelheight)*(1-(math.abs(self.environment.camera.modelangle)/(math.pi/2)))
-- --						+(self.modelwidth)*(math.abs(self.environment.camera.modelangle)/(math.pi/2))

	-- --self.clickarea.height=(self.modelheight)*(math.cos(self.environment.camera.modelangle))
-- --						+(self.modelwidth)*(math.sin(self.environment.camera.modelangle))

	-- self.clickarea.height=(self.modelvisibleheight)*(math.cos(self.environment.camera.modelangle))
						-- +(self.modelwidth)*(-math.sin(self.environment.camera.modelangle))
		
	
						
	-- --print("PlayerCharacter:SetClickability "..self.modelheight.." "..self.modelwidth.." "..math.cos(self.environment.camera.modelangle).." "..math.sin(self.environment.camera.modelangle).." "..self.clickarea.height)
	-- --print("PlayerCharacter:SetClickability "..self.clickarea.height)
end



function TRAININGGROUNDS_PlayerCharacter:SetModelSpecificInfo()	
	-- -- Reminder to self that under certain conditions, calling SetCustomRace()
	-- -- is potentially a violation of the World of Warcraft User Interface Add-On Development Policy.

	
	-- do not call super
	self.modelinfo={}

	self.currentanimation=0
	--self.currentfacing=math.pi
	--self.currentfacing=math.pi-0.5
	self.currentfacing=math.pi*-.667


	
	local modelinfo,race,sex=TRAININGGROUNDS_PlayerCharacterModelInfo.SetModelframeToPlayerAndReturnModelInfo(self.modelframe)
	self.modelinfo=modelinfo
	self.race=race
	self.sex=sex
	
	
	--TODO: ask environment or game if we're using any custom equipment
	self.equipment=TRAININGGROUNDS_PlayerCharacterModelInfo.GetPlayerDefaultEquipment()
	-- monks:
	self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["MainHandSlot"]]=nil	
	self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["SecondaryHandSlot"]]=nil	

	-- -- for now, just set equipment to nil to avoid hidehelm/hidecape problems
	-- self.equipment=nil
	if(not ShowingHelm())then self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["HeadSlot"]]=nil end
	if(not ShowingCloak())then self.equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["BackSlot"]]=nil end	
	
	local customrace=nil
	local customsex=nil
	-- local customrace=26
	-- local customsex=1
	
	if(customrace~=nil)then self.race=customrace end
	if(customsex~=nil)then self.sex=customsex end
	
	self.modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(self.modelframe,self.equipment,customrace,customsex)
	-- --self.modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(self.modelframe,self.equipment,TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Human"],1)	
	
	
	
	-- -----------------
	-- self.modelframe:TryOn(119583)	-- Mistdancer Vest
	-- self.modelframe:TryOn(119591)	-- Mistdancer Boots
	-- self.modelframe:TryOn(119586)	-- Mistdancer Helm
	-- self.modelframe:TryOn(119587)	-- Mistdancer Legguards
	-- self.modelframe:TryOn(119601)	-- Mistdancer Shoulders
	-- self.modelframe:TryOn(119589)	-- Mistdancer Cord
	-- self.modelframe:TryOn(119590)	-- Mistdancer Cuffs
	-- self.modelframe:TryOn(119585)	-- Mistdancer Handguards
	-- self.modelframe:UndressSlot(4)	-- shirt
	-- self.modelframe:UndressSlot(15)	-- back
	-- ----------------
	-- self.modelframe:TryOn(94997)	-- T15 Heroic (Mythic)
	-- self.modelframe:TryOn(95032)	
	-- self.modelframe:TryOn(96386)	
	-- self.modelframe:TryOn(96405)	
	-- self.modelframe:TryOn(96457)	
	-- self.modelframe:TryOn(96488)	
	-- self.modelframe:TryOn(96493)	
	-- self.modelframe:TryOn(96612)	
	-- self.modelframe:UndressSlot(4)	-- shirt
	-- self.modelframe:UndressSlot(15)	-- back	
	-- -- ----------------
	-- self.modelframe:TryOn(113601)	-- T17 Mythic
	-- self.modelframe:TryOn(113845)	
	-- self.modelframe:TryOn(113895)	
	-- self.modelframe:TryOn(113907)	
	-- self.modelframe:TryOn(113924)	
	-- self.modelframe:TryOn(113949)	
	-- self.modelframe:TryOn(113989)	
	-- self.modelframe:UndressSlot(4)	-- shirt
	-- self.modelframe:UndressSlot(15)	-- back	
	-- ----------------		
	
	-- if(true)then --!!!
		-- self.modelframe:TryOn(128039)	-- T17 Raid Finder	-- use this one for demo videos
		-- --self.modelframe:TryOn(128034)	-- helmet
		-- self.modelframe:TryOn(90844)	-- shadopan helmet
		-- self.modelframe:TryOn(128046)	
		-- self.modelframe:TryOn(128047)	
		-- self.modelframe:TryOn(128121)	
		-- self.modelframe:TryOn(128137)	
		-- self.modelframe:TryOn(128054)	
		-- self.modelframe:TryOn(128076)		
		 -- --self.modelframe:TryOn(89800)	-- shadopan tabard
		 -- self.modelframe:UndressSlot(4)	-- shirt
		 -- self.modelframe:UndressSlot(19)	-- tabard
		-- --self.modelframe:UndressSlot(15)	-- back	
		-- --self.modelframe:TryOn(102248)	-- MoP legendary cape
		-- self.modelframe:TryOn(29382)		-- Blood Knight War Cloak (ilvl 110)
		-- -- ----------------	
		-- -- self.modelframe:SetCustomRace(11,1)		-- Not a reference to anything.	
		-- -- self.modelframe:Undress()	
		-- -- self.modelframe:TryOn(6795)
		-- -- self.modelframe:TryOn(19506)					
		-- -- self.modelframe:TryOn(78206)
		
		-- -- ----------------	
		-- self.modelframe:UndressSlot(16)	--mainhand
		-- self.modelframe:UndressSlot(17)	--offhand
		-- self.modelframe:TryOn(89575)		-- Handwraps of Serenity
		-- self.modelframe:TryOn(89575)		-- Handwraps of Serenity
	-- end


	self.modelframe:UndressSlot(16)	--mainhand
	self.modelframe:UndressSlot(17)	--offhand
	self.modelframe:TryOn(89575)		-- Handwraps of Serenity
	self.modelframe:TryOn(89575)		-- Handwraps of Serenity

	
	
	-- -- Small Illusionary Guardian
	-- self.modelframe:SetDisplayInfo(48902)
	-- self.modelinfo.sideviewoffsetY=179
	-- self.modelinfo.sideviewclickheight=172
	-- self.modelinfo.topviewoffsetY=-55
	-- self.modelinfo.clickwidth=95
	-- self.modelinfo.offsetX=-20
	-- self.modelinfo.gameplayscaleratio=1	
	

	
	
	

	-- -- Spinning Crane Kick effect
	-- local temp=TRAININGGROUNDS_ReusableModelFrames.getFrame()
	-- --temp:SetAllPoints(self.modelframe)
	-- temp:SetPoint("CENTER",self.modelframe,"CENTER",0,550)
	-- temp:SetWidth(800)
	-- temp:SetHeight(1600)
	-- temp:Show()
	-- temp:SetModel(0)
	-- temp:SetModel("SPELLS\\Monk_Cranekick_State.M2")
	-- --temp:SetModelScale(0.25)
	-- temp:SetModelScale(.125)
	-- temp:SetPosition(-1,-.75,0)
	-- temp:SetParent(self.modelframe)
	-- temp:SetFrameLevel(255)
	-- temp:SetSequenceTime(0,500)
	-- temp:Show()
	
	
end

-- function TRAININGGROUNDS_PlayerCharacter:SetNameplate()
	-- TRAININGGROUNDS_WoWCharacter.SetNameplate(self)
	-- --self.nameplate.border:Hide()
	-- --self.nameplate.fill:Hide()
	-- --self.nameplate.hurt:Hide()
-- end


function TRAININGGROUNDS_PlayerCharacter:step(elapsed,currenttime)
	TRAININGGROUNDS_WoWCharacter.step(self,elapsed,currenttime)

	if(_TRAININGGROUNDS.game.keys.tab.pressed)then	
		if(self.combat~=nil)then
			self.combat:Autotarget()
		end
	end
	
	if(_TRAININGGROUNDS.game.keys.esc.pressed)then	
		if(self.combat~=nil and self.combat.target~=nil)then
			self.combat:ChangeTarget(nil)
		else		
			if(self.pausemenucontroller~=nil)then				
				self.pausemenucontroller:ToggleMenu()
			end			
		end
	end	
	
	local k,v
	if(_TRAININGGROUNDS.game.keys.mouseM.pressed)then	
		for k,v in ipairs(self.combat.spellbuttons) do	
			if(v.key=="8" and v.shift==false and v.ctrl==false)then
				--print("Game.lua " .. tostring(v.spell))
				--print("Game.lua " .. v.spell.spellname)
				self.combat:tryQueueSpell(v.spell)
			end
		end
	end
end


function TRAININGGROUNDS_PlayerCharacter.CanPlayerDW()
	-- TODO: specs are subject to change in 7.0
	local localspecid=GetSpecialization()
	if(localspecid==nil)then 
		-- Player hasn't loaded yet!  Try again later
		-- (or panic; we should only get here if we autostart during loading screen)
		return false 
	end
	
	local globalspecid=GetSpecializationInfo(GetSpecialization())
	local classid=UnitClass("player")
	if(	   globalspecid==251	-- Frost DK
		or globalspecid==253	-- Beast Mastery Hunter
		or globalspecid==254	-- Marksmanship Hunter
		or globalspecid==255	-- Survival Hunter
		or globalspecid==268	-- Brewmaster Monk
		or globalspecid==269	-- Windwalker Monk
		--or globalspecid==259	-- Assassination Rogue
		--or globalspecid==260	-- Combat Rogue
		--or globalspecid==261	-- Subtlety Rogue
		or globalspecid==72 	-- Fury Warrior
		or globalspecid==263	-- Enhancement Shaman
		--or globalspecid==577	-- Havoc DH
		--or globalspecid==581	-- Vengeance DH
		or classid==4			-- All Rogues
		or classid==12			-- All DHs
		)then
		return true
	end
	
	return false				
end