--
-- TrainingGrounds is still undergoing construction by DagnerousPadna.
-- Please don't redistribute this addon until official release.
--

TRAININGGROUNDS_PreviousErrorHandler=geterrorhandler()


function TRAININGGROUNDS_ErrorHandler(...)
	--if(_TRAININGGROUNDS.alreadyattemptedshutdown~=true)then
		print("|cFFFF0000A Lua error was detected.  Shutting down TrainingGrounds to avoid a potential client crash.")
	--end	
	--setpreviouserrorhandler has been moved to shutdown
	_TRAININGGROUNDS:Shutdown()
	
	TRAININGGROUNDS_PreviousErrorHandler(...)
end





-- our main local object
local TRAININGGROUNDS={};

-- some global trickery that allows SlashCmdList, and some other classes, to communicate with the local object
if(_TRAININGGROUNDS==nil) then _TRAININGGROUNDS=TRAININGGROUNDS; end

TRAININGGROUNDS.VERSIONSTRING="2016-04-18c"
TRAININGGROUNDS.WINDOWCAPTION="TrainingGrounds version "..TRAININGGROUNDS.VERSIONSTRING

-- the event handler
TRAININGGROUNDS.Frame = CreateFrame("Frame")

-- some trickery to make sure we only run the init code once
if(TRAININGGROUNDS_LOADING==nil)then	TRAININGGROUNDS_LOADING=false;  end
if(TRAININGGROUNDS_LOADED==nil)then	TRAININGGROUNDS_LOADED=false;  end

-- this is set whenever esc is pressed
-- it counts down from its current value and forcequits when it reaches zero
-- measured in milliseconds
TRAININGGROUNDS.forceshutdowntimer=nil
TRAININGGROUNDS.FORCESHUTDOWNDURATION=5000

-- set this to true as soon as we load the game
TRAININGGROUNDS.require_reload=nil

TRAININGGROUNDS.OnVarsLoaded=function(self)
	if(TRAININGGROUNDS_VARS==nil) then TRAININGGROUNDS_VARS={} end
	--print("TRAININGGROUNDS.OnVarsLoaded warning: "..tostring(TRAININGGROUNDS_VARS.acceptedwarning))
end

TRAININGGROUNDS.Frame.OnLoad=function(self,AddOn)
	--print("AddOn: "..AddOn)
	if(AddOn=="TrainingGrounds" and TRAININGGROUNDS_LOADING==false and TRAININGGROUNDS_LOADED==false) then		
		TRAININGGROUNDS_LOADING=true
		-- TRAININGGROUNDS_SetDebugVars is defined in TrainingGrounds_Debug.lua  (read: may or may not be defined)
		if(TRAININGGROUNDS_SetDebugVars~=nil)then
			TRAININGGROUNDS_SetDebugVars(TRAININGGROUNDS)
		end
		TRAININGGROUNDS.Frame:UnregisterEvent("ADDON_LOADED")		
		TRAININGGROUNDS:OnVarsLoaded()					
		TRAININGGROUNDS:init()
	
		
		print("TrainingGrounds is enabled.  Type /tg to play.")
		TRAININGGROUNDS_LOADED=true		
				
	end 
end

TRAININGGROUNDS.Frame.OnEvent=function(self,event, ...)
	--print("Hello World! " .. event)
	if(event=="ADDON_LOADED") then
		--TRAININGGROUNDS:OnLoad() --!!!
		TRAININGGROUNDS.Frame:OnLoad(...)
	end
end

TRAININGGROUNDS.Frame:RegisterEvent("ADDON_LOADED")
TRAININGGROUNDS.Frame:SetScript("OnEvent", TRAININGGROUNDS.Frame.OnEvent)


TRAININGGROUNDS.Frame.OnUpdate=function(self,elapsed)
	--TODO: if esc is held, draw forceshutdowntimer in UI environment
	if(TRAININGGROUNDS.forceshutdowntimer~=nil) then	
		TRAININGGROUNDS.forceshutdowntimer=TRAININGGROUNDS.forceshutdowntimer-elapsed*1000
		if(TRAININGGROUNDS.forceshutdowntimer<=0)then
			TRAININGGROUNDS:Shutdown()
			return
		end
	end

	if(TRAININGGROUNDS.dead==true)then
		TRAININGGROUNDS:Shutdown()
		return
	end

	if(TRAININGGROUNDS.game~=nil)then
		TRAININGGROUNDS.game:step(elapsed)
	end
	if(TRAININGGROUNDS.game~=nil)then
		TRAININGGROUNDS.game:draw(elapsed)
	end
end

TRAININGGROUNDS.Frame.OnKeyDown=function(self,key)
	--print("TrainingGrounds.OnKeyDown"..key)

	if(key=="ENTER") then
		-- ENTER key passes through so the player can still access chat
		TRAININGGROUNDS.Frame:SetPropagateKeyboardInput(true)
	else
		-- (i still can't believe this works.  would not be surprised if it breaks in a future patch)
		TRAININGGROUNDS.Frame:SetPropagateKeyboardInput(false)
	end
	
	if(key=="ESCAPE") then
		if(TRAININGGROUNDS.debug_instantquit==true) then
			TRAININGGROUNDS:Shutdown()
			return
		end
		if(TRAININGGROUNDS.debug_instantshiftquit==true)then
			if(TRAININGGROUNDS.game.keys.shift.current==true)then
				TRAININGGROUNDS:Shutdown()
				return
			end
		end
		if(TRAININGGROUNDS.forceshutdowntimer==nil)then
			TRAININGGROUNDS.forceshutdowntimer=TRAININGGROUNDS.FORCESHUTDOWNDURATION --TODO: const
		end
	end

	
	TRAININGGROUNDS.game:OnKeyChange(key,true)
end


TRAININGGROUNDS.Frame.OnKeyUp=function(self,key)
	if(key=="ESCAPE") then
		TRAININGGROUNDS.forceshutdowntimer=nil
	end
	
	TRAININGGROUNDS.game:OnKeyChange(key,false)	
end

TRAININGGROUNDS.die=function(self)
	self.dead=true
end

TRAININGGROUNDS.Shutdown=function(self)
	if(self.alreadyattemptedshutdown==false)then		
		seterrorhandler(TRAININGGROUNDS_PreviousErrorHandler)
		
		self.alreadyattemptedshutdown=true
		self.dead=true	--!!!
		
		TRAININGGROUNDS.forceshutdowntimer=nil
		
		-- disable keyboard
		TRAININGGROUNDS.Frame:EnableKeyboard(false)
		if(TRAININGGROUNDS.game~=nil)then
			TRAININGGROUNDS.game.mouse_input_enabled=false
			TRAININGGROUNDS.game.frame:EnableMouseWheel(false)
		end
		-- TODO: at the moment only the chat frame is restored for debug purposes
		-- finished game should restore more than just chat
		if(TRAININGGROUNDS.debug_hidechat==true) then
			ChatFrame1:Show()
			ChatFrame1Tab:Show()
			DEFAULT_CHAT_FRAME:SetScript("OnShow",DEFAULT_CHAT_FRAME.Show)
			DEFAULT_CHAT_FRAME:Show()
		end			

		
		self:Cleanup()
		
			-- TODO: check if force quit message was already displayed
		print("TrainingGrounds was shut down.  To restart it, /reload the UI then type /tg.")
		--print("TrainingGrounds force quit.  To restart it, type /tg.")		
		
	end
	
end



TRAININGGROUNDS.Frame.OnMouseDownGameScreen=function(self,button)
	-- local globalx,globaly=GetCursorPosition()
	-- local left,bottom=TRAININGGROUNDS.game.frame:GetRect()
	-- local localx=globalx-left
	-- local localy=globaly-bottom
	
	--print("OnMouseDownGameScreen")
	
	TRAININGGROUNDS.game:OnMouseChange(button,true)			
end

TRAININGGROUNDS.Frame.OnMouseUpGameScreen=function(self,button)
	TRAININGGROUNDS.game:OnMouseChange(button,false)		
end

TRAININGGROUNDS.Frame.OnMouseWheelGameScreen=function(self,delta)
	TRAININGGROUNDS.game:OnMouseWheel(delta)
end

TRAININGGROUNDS.Frame.OnEventGameScreen=function(self,event,...)
	TRAININGGROUNDS.game:OnEvent(event,...)
end

modelFrame=nil

TRAININGGROUNDS.init=function(self)	
	-- TRAININGGROUNDS.resetgame()
	-- TRAININGGROUNDS.Frame:SetScript("OnUpdate", TRAININGGROUNDS.Frame.OnUpdate)
	-- TRAININGGROUNDS.Frame:SetScript("OnKeyDown", TRAININGGROUNDS.Frame.OnKeyDown)
	-- TRAININGGROUNDS.Frame:SetScript("OnKeyUp", TRAININGGROUNDS.Frame.OnKeyUp)
	-- -- TRAININGGROUNDS.Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	-- -- TRAININGGROUNDS.Frame:RegisterEvent("PLAYER_REGEN_ENABLED")	
	
	
	--preload the player character model so it's cached when the game starts
	-- (not effective if debug_autostart is on)
	local frame=CreateFrame("DressUpModel",framename,UIParent)
	frame:SetUnit("player")
	frame:Hide()
	

	if(TRAININGGROUNDS.debug_autostart)then
		TRAININGGROUNDS:resetgame()
	end
end

TRAININGGROUNDS.initgame=function(self)
	if(TRAININGGROUNDS.initialized==nil or TRAININGGROUNDS.initialized==false) then		
		-- super secret debug sandbox frame
		if(false) then
			local f=CreateFrame("Frame","myDebugFrame",UIParent)
			f:SetPoint("TOPLEFT",0,0)
			f:SetWidth(100)
			f:SetHeight(100)
			local t=f:CreateTexture("myDebugTexture")			
			t:SetAllPoints(f)
			SetPortraitToTexture("myDebugTexture", "Interface\\Icons\\Spell_Fire_Burnout")
			f.texture=t
			t:Show()
			f:Show()
		end
		--extra debug options
		if(TRAININGGROUNDS.debug_hidemost==true) then
			PlayerFrame:Hide()
			MinimapCluster:Hide()
			MainMenuBar:Hide()
			BuffFrame:Hide()
			ObjectiveTrackerFrame:Hide()	
			--print("TrainingGrounds.lua hidemost")			
			CompactRaidFrameManager:Hide() 
			CompactRaidFrameContainer:Hide() 
			ConsolidatedBuffs:Hide()
		end
		if(TRAININGGROUNDS.debug_hidechat==true) then
			ChatFrame1:Hide()
			ChatFrame1Tab:Hide()
			ChatFrame2:Hide()
			ChatFrame2Tab:Hide()
			ChatFrame3:Hide()
			ChatFrame3Tab:Hide()
			ChatFrame4:Hide()
			ChatFrame4Tab:Hide()
			ChatFrame5:Hide()
			ChatFrame5Tab:Hide()
			FriendsMicroButton:Hide()
			local chat = DEFAULT_CHAT_FRAME
			chat:SetScript("OnShow", chat.Hide)
			chat:Hide()
			ChatFrameMenuButton:Hide()		
			--print("TrainingGrounds.lua hidechat")
		end
			
		TRAININGGROUNDS.initialized=true
		
		for k,v in ipairs(ChatFrame1EditBox) do 
			print(tostring(k))
		end
	end
end

TRAININGGROUNDS.resetgame=function(self)		
	if(TRAININGGROUNDS.game~=nil)then
		print("TrainingGrounds appears to be running already.  If something broke, type /tg shutdown.")
	end
	if(TRAININGGROUNDS.require_reload~=nil and _TRAININGGROUNDS.debug_dontrequirereload~=true)then
		print("Please /reload the UI before running TrainingGrounds again.  (You won't have to do this in the finished game.)")
		return
	end

		
	if(TRAININGGROUNDS.debug_donthookerrorhandler~=true)then
		seterrorhandler(TRAININGGROUNDS_ErrorHandler)	
	end
	
	self.alreadyattemptedshutdown=false
	TRAININGGROUNDS.dead=false
	TRAININGGROUNDS.require_reload=true
	TRAININGGROUNDS:initgame()
	if(TRAININGGROUNDS.game==nil)then	
		--TRAININGGROUNDSGameScreen:SetPoint("CENTER",0,0)
		
		TRAININGGROUNDS.game=TRAININGGROUNDS_Game:new()
		TRAININGGROUNDS.game:setup()	
		
		TRAININGGROUNDS.Frame:SetScript("OnUpdate", TRAININGGROUNDS.Frame.OnUpdate)
		TRAININGGROUNDS.Frame:SetScript("OnKeyDown", TRAININGGROUNDS.Frame.OnKeyDown)
		TRAININGGROUNDS.Frame:SetScript("OnKeyUp", TRAININGGROUNDS.Frame.OnKeyUp)		
		
		TRAININGGROUNDS.game.frame:SetScript("OnMouseDown", TRAININGGROUNDS.Frame.OnMouseDownGameScreen)
		TRAININGGROUNDS.game.frame:SetScript("OnMouseUp", TRAININGGROUNDS.Frame.OnMouseUpGameScreen)		
		TRAININGGROUNDS.game.frame:SetScript("OnMouseWheel", TRAININGGROUNDS.Frame.OnMouseWheelGameScreen)
		TRAININGGROUNDS.game.frame:RegisterEvent("UI_SCALE_CHANGED")
		TRAININGGROUNDS.game.frame:SetScript("OnEvent",TRAININGGROUNDS.Frame.OnEventGameScreen)
		
	else
		--TODO:
	end
end




SLASH_TRAININGGROUNDS1 = "/tg"

function SlashCmdList.TRAININGGROUNDS(msg,editbox)
	if(TRAININGGROUNDS_LOADED==false)then return; end
	--print(_TRAININGGROUNDS.game.timer)
	
	

	local args={}
	local i=0
	for arg in string.gmatch(msg, "%S+") do	
		args[i]=arg
		i=i+1
		--print(arg)
	end	
		
	if(#args==0 and args[0]==nil)then
		TRAININGGROUNDS:resetgame()
	end
	
	--TODO LATER: move to debug commands
	if(args[0]=="reset") then		
		print("To delete all TrainingGrounds saved data, type /tg reset confirm")
	end 	
	if(args[0]=="reset" and args[1]=="confirm") then
		if(_TRAININGGROUNDS.game~=nil)then		
			_TRAININGGROUNDS:Shutdown()
		end		
		TRAININGGROUNDS_VARS={}
		print("TrainingGrounds data has been reset.")
	end 
	if(args[0]=="shutdown")then
		_TRAININGGROUNDS:Shutdown()
	end
	
	if(_TRAININGGROUNDS.debug_enableextraslashcommands==true)then
		if(args[0]=="anim" and args[1]~=nil)then
			_TRAININGGROUNDS.game.environment_world.player.attackanimationendtick=_TRAININGGROUNDS.game.currenttime+60*1000
			_TRAININGGROUNDS.game.environment_world.player:changeFrameAnimationAndOverride(args[1])		
		end
		if(args[0]=="eq")then
			--_TRAININGGROUNDS.game.environment_world.player.modelframe:TryOn(19019,args[1])
			--_TRAININGGROUNDS.game.environment_world.player.modelframe:TryOn(19019,nil,nil,nil,nil,nil,nil)
			--_TRAININGGROUNDS.game.environment_world.player.modelframe:TryOn(18392,args[1])
			_TRAININGGROUNDS.game.environment_world.player.modelframe:TryOn(tonumber(args[1]),args[2])
			--9914, 36464: mace-style "scepter" frill
			--11928: fork-style "scepter" frill
			--9769, 16887: "branch" frills, resemble very small daggers
			--32520: blue "orb" frill, but with impressive glowing effect
			--29271, 129839: "talisman of kalecgos" -- frost effect
		end
		if(args[0]=="report")then
			TRAININGGROUNDS_ReusableFrames.Report()
		end		
		if(args[0]=="foo")then
			-- local currentSpec = GetSpecialization() -- Get the player's current spec
			-- local spellID, levelLearned = GetSpecializationSpells(currentSpec) -- Get the spellID and level learned of the first spell of this spec.
			-- local spellName = GetSpellInfo(spellID) -- Get the spell name
			-- print("Your specialization's first spell is " .. spellName .. " (spellID " .. spellID .. ") and is learned at level " .. levelLearned .. "!") -- Print it all out to chat
			
			-- local currentSpec = GetSpecialization() -- Get the player's current spec
			-- local spells = {GetSpecializationSpells(currentSpec)} -- Get the spellID and level learned of the first spell of this spec.			
			-- for i=1,#spells,2 do
				-- local spellName = GetSpellInfo(spells[i]) -- Get the spell name
				-- local levelLearned = spells[i+1]  -- Get the spell name
				-- print("Your specialization's spell is " .. spellName .. " (spellID " .. spells[i] .. ") and is learned at level " .. tostring(levelLearned) .. "!") -- Print it all out to chat
			-- end
			
			-- local spellname="-"
			-- local i=1
			-- local j=args[1]
			-- if(j==nil)then j=1 end
			-- for i=j,j+999,1 do
				-- spellname=GetSpellBookItemName(i,"spell")
				-- if(spellname~=nil)then
					-- print(i..": "..tostring(spellname))
				-- end
				-- i=i+1
			-- end
			
			
			
			
			
		end

	end
	
	
	
	if(args[0]~=nil) then
		--facing=args[0]
	end
		
	--resetAllUnactiveTempFrames()
	
end







TRAININGGROUNDS.Cleanup=function(self)
	if(self.game~=nil)then
		self.game:Cleanup()				
		TRAININGGROUNDS_ReusableFrames.ResetAndReport()
	end
	--TODO: move these to game:cleanup
	-- (and move event setup to game:setup?)
	self.game.frame:SetScript("OnMouseDown", nil)
	self.game.frame:SetScript("OnMouseUp", nil)		
	self.game.frame:SetScript("OnMouseWheel", nil)
	self.game.frame:UnregisterEvent("UI_SCALE_CHANGED")
	self.game.frame:SetScript("OnEvent",nil)
	
	self.game=nil
	
	--TODO: these will probably be moved to self.game later
	self.Frame:SetScript("OnUpdate", nil)
	self.Frame:SetScript("OnKeyDown", nil)
	self.Frame:SetScript("OnKeyUp", nil)
	
	self.initialized=false
end

TRAININGGROUNDS_OnLogout=function()
	TRAININGGROUNDS.acceptedwarningbeforelogout=TRAININGGROUNDS_VARS.acceptedwarning

	TRAININGGROUNDS_VARS.acceptedwarning=false
end
TRAININGGROUNDS_OnCancelLogout=function()
	TRAININGGROUNDS_VARS.acceptedwarning=TRAININGGROUNDS.acceptedwarningbeforelogout
end


-- www.wowinterface.com/forums/archive/index.php/t-52846.html
-- Hook quit/logout functions to detect when the player changes characters
local _Quit=Quit
local _Logout=Logout
local _CancelLogout=CancelLogout
function CancelLogout()
	TRAININGGROUNDS_OnCancelLogout()
	return _CancelLogout()
end
function Quit()
	TRAININGGROUNDS_OnLogout()
	return _Quit()
end
function Logout()
	TRAININGGROUNDS_OnLogout()
	return _Logout()
end




----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------

----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------






-- TODO: move this function somewhere else
function TRAININGGROUNDS:round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function TRAININGGROUNDS:ChatColorToARGB(chatcolor)
	-- e.g. |cFFFF0000
	
	-- Lua substrings are weird -- 2nd argument is ending character, not length
		
	local a,r,g,b
	a=tonumber(chatcolor:sub(3,4),16)/256.0
	r=tonumber(chatcolor:sub(5,6),16)/256.0	
	g=tonumber(chatcolor:sub(7,8),16)/256.0	
	b=tonumber(chatcolor:sub(9,10),16)/256.0
	return a,r,g,b
	
end

-- wowwiki.wikia.com/wiki/USERAPI_tinsertbeforeval
-- tremovebyval: remove a table row given its value
-- TODO: change to TRAININGGROUNDS_tremovebyval (or don't?  makes it harder to name future classes)
function TRAININGGROUNDS:tremovebyval(tab, val)
   for k,v in pairs(tab) do
     if(v==val) then
       table.remove(tab, k)
       return true
     end
   end
   return false
end
 
function TRAININGGROUNDS_tcontains(tab,val)
    for k,v in pairs(tab) do
     if(v==val) then
       return true
     end
   end
   return false
end
 
-- lua-users.org/wiki/InheritanceTutorial
function TRAININGGROUNDS_inheritsFrom(baseClass)
	local new_class={}
	local class_mt={__index=new_class}
	function new_class:new()
		local newinst={}
		setmetatable(newinst,class_mt)
		return newinst
	end
	if baseClass~=nil then
		setmetatable(new_class,{__index=baseClass})		
	else
		print("WARNING: TRAININGGROUNDS_inheritsFrom was given nil as its base class.  (we don't know which class is the parent)")
		local x=ThisLineWillThrowAnError.TODOMoreGracefulWayOfTHrowingError
	end
    function new_class:class()
        return new_class
    end
	-- WARNING: do not use superClass to access parent functions.
	-- 		doing so will result in 1 of 2 problems:
	-- 		"self" will change to refer to the superclass metatable instead of the child instance,
	--		or "self" will still refer to the child instance and cause an infinite loop if you call superClass again.
	-- to access parent functions, call the parent function directly:
	-- PARENTCLASSNAME.function(self, args)
	-- do not use colon operator -- doing so will cause self to change from child instance to class table!
    function new_class:superClass()		
        return baseClass
    end
    function new_class:isa( theClass )
        local b_isa = false
        local cur_class = new_class
        while ( nil ~= cur_class ) and ( false == b_isa ) do
            if cur_class == theClass then
                b_isa = true
            else
				if(cur_class.superClass~=nil)then
					cur_class = cur_class:superClass()
				else
					cur_class=nil
				end
            end
        end
        return b_isa
    end	
	
	return new_class
end

--TODO: rename TRAININGGROUNDS_round
--SOURCE: wowwiki.wikia.com/wiki/USERAPI_round
function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

--TODO:
signum=function(x)
	if x<0 then
		return -1
	elseif x>0 then
		return 1
	else
		return 0
	end
end

--SOURCE: stackoverflow.com/questions/1073336/circle-line-segment-collision-detection-algorithm#
function TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,cx,cy,r)

	local dot=function(v1,v2)		
			return v1[1]*v2[1]+v1[2]*v2[2]
		end
	local d={(x2-x1),(y2-y1)}
	local f={(x1-cx),(y1-cy)}
	
	
	local a=dot(d,d)
	local b=2*dot(f,d)
	local c=dot(f,f)-r*r
	
	local discriminant=b*b-4*a*c
	if(discriminant<0)then
		return false
	else
		discriminant=math.sqrt(discriminant)
		local t1=(-b - discriminant)/(2*a)
		local t2=(-b + discriminant)/(2*a)
		if(t1>=0 and t1<=1) then
			return true
		end
		if(t2>=0 and t2<=1) then
			return true
		end
		return false
	end
	
end

function TRAININGGROUNDS_FrameVisibilityCheck(frame)
	_TRAININGGROUNDS:debug_print("Checking frame "..tostring(frame))
	_TRAININGGROUNDS:debug_print("Parent: "..tostring(frame:GetParent()))
	_TRAININGGROUNDS:debug_print("Width: "..frame:GetWidth())
	_TRAININGGROUNDS:debug_print("Height: "..frame:GetHeight())	
	_TRAININGGROUNDS:debug_print("Framelevel: "..frame:GetFrameLevel())	
end

function TRAININGGROUNDS:debug_print(str)
	if(self.debug_enable_debug_print==true)then
		print(str)
	end
end